//+------------------------------------------------------------------+
//|                  Currency_Strength_Meter_Dashboard-Indicator.mq4 |
//|         Nicole Wagner, Professional Financial Markets Programmer |
//|     https://www.mql5.com/en/users/professionalmqlcoder/feedbacks |
//+------------------------------------------------------------------+
#property copyright "Nicole Wagner, Professional Financial Markets Programmer"
#property link      "https://www.mql5.com/en/users/professionalmqlcoder/feedbacks"
#property version   "1.00"
#property strict
#property indicator_chart_window

//---------- Currency Strength Index Indicator ------////

double    spr, pnt, tickval, ccy_strength[8];
int       dig, tifr, ccy_count[8], ccCP,RefreshEveryXMins0;
string    IndiName, ccy, CP[40],CurrencyPairs0;
datetime  prev_time;
string LastCurrency;

int tf;
double SCurr,WCurr;
ENUM_TIMEFRAMES TF[]={PERIOD_CURRENT,PERIOD_M1,PERIOD_M2,PERIOD_M3,PERIOD_M4,PERIOD_M5,PERIOD_M6,PERIOD_M10,PERIOD_M12,PERIOD_M15,PERIOD_M20,PERIOD_M30,PERIOD_H1,PERIOD_H2,PERIOD_H3,PERIOD_H4,PERIOD_H6,PERIOD_H8,PERIOD_H12,PERIOD_D1,PERIOD_W1,PERIOD_MN1};
string TimeFr[]={"0","M1","M2","M3","M4","M5","M6","M10","M12","M15","M20","M30","H1","H2","H3","H4","H6","H8","H12","D1","W1","MN"};
string Currency[]={"USD","EUR","GBP","CHF","CAD","AUD","JPY","NZD"};
string Prefix,Suffix,TradeComment,Vs[100][100];

double USD,EUR,GBP,CHF,CAD,AUD,JPY,NZD;

//---------- Currency Strength Index Indicator ------////

const int ValueOrIndex0 = 0, ValueOrIndex1 = 1;
const int TotalCurrencies = 8;
int NumOfCurrencies;
const string CurrencyArray[] = {"USD","EUR","GBP","CHF","CAD","AUD","JPY","NZD"};
const int USD_Buffer = 0, EUR_Buffer = 1, GBP_Buffer = 2, CHF_Buffer = 3, CAD_Buffer = 4, AUD_Buffer = 5, JPY_Buffer = 6, NZD_Buffer = 7;

input string CurrencyStrengthIndexIndicatorProperties = "====== CurrencyStrengthIndex Indicator Properties ======";
enum CurrNames {_USD,_EUR,_GBP,_CHF,_CAD,_AUD,_JPY,_NZD};
enum IndAlerts {Disabled,Enabled,IncludeReverse};
input string                CurrencyPairs                    = "GU,UF,EU,UJ,UC,NU,AU,AN,AC,AF,AJ,CJ,FJ,EG,EA,EF,EJ,EN,EC,GF,GA,GC,GJ,GN,NJ";
input CurrNames             StrongCurrency                   = _EUR;
input double                StrengthLimit                    = 6;
input CurrNames             WeakCurrency                     = _USD;
input double                WeaknessLimit                    = 3;
IndAlerts             SendEmail                        = 0;
IndAlerts             SendNotifications                = 0;
IndAlerts             Alerts                           = 0;
string                AlertSound                       = "alert.wav";
IndAlerts             ScreenShots                      = 0;
int                   AlertsIntervalMinutes            = 1;
ENUM_BASE_CORNER      PanelCorner                      = CORNER_LEFT_UPPER;
int                   CSI_FontSize                     = 0;
string                FontType                         = "Courier New";
int                   HorizPos                         = 10;
int                   VertPos                          = 25;
int                   VertSpacing                      = 25;
input int                   RefreshEveryXMins                = 0;
color                 Color1                           = clrRed;
double                Level1                           = 7.0;
color                 Color2                           = clrOrange;
double                Level2                           = 5.0;
color                 Color3                           = clrYellow;
double                Level3                           = 2.0;
color                 Color4                           = clrDodgerBlue;
double                Level4                           = 0.0;

input string IndicatorProperties = "====== Indicator Properties ======";
input string ExcludePairs = "";
input string Symbol_Suffix = "";
input double ExcludeValueRange_Min = 0;
input double ExcludeValueRange_Max = 0;
input string ExcludeCurrencyCombination = "";

input double CurrencyTrendMeterStrength_Min = 50;
input double CurrencyTrendMeterStrength_Max = 90;
input bool StrongWeakCurrencyActiveForTrendMeter = true;
input double StrongCurrencyLimit = 6.5;
input double WeakCurrencyLimit = 3.3;

input double CurrencyRangeMeterStrength_Min = 20;
input double CurrencyRangeMeterStrength_Max = 49;

input string TemplateFileName = "MyTemplate.tpl"; //TemplateFileName located in \MQL4\Files

input string DashboardProperties = "====== Dashboard Properties ======";
enum Enum_TableType {Default=1, Priority=2, Favorite=3};
input Enum_TableType DefaultTable = Priority;
input string FavoritSymbols = "EURUSD,USDJPY";
input string FontName = "Arial";

input int TableType_XOffset = 10;
input int TableType_YOffset = 10;
input int TableType_ShowHide_XOffset = 120;
input int TableType_Signals_XOffset = 150;
input int TableType_Width = 100;
input int TableType_Height = 20;
input int TableType_FontSize = 12;
input int TableType_ShowHide_FontSize = 15;
input color TableType_TextColor = clrBlack;
input color TableType_ShowHide_Color = clrBlue;
input color TableType_Signals_TextColor = clrWhite;
input color TableType_BackColor = clrYellow;
input color TableType_Signals_BackColor = clrLimeGreen;

input int HeaderFontSize = 10;
input int FontSize = 10;
input int Table_XOffset = 10;
input int Table_YOffset = 40;
input int SymbolNameCellWidth = 70;
input int SymbolStrengthCellWidth = 70;
input int HeaderCellHeight = 25;
input int CellHeight = 18;
input color CurrencyMeterHeaderTextColor = clrBlack;
input color CurrencyMeterTextColor = clrBlack;
input color CurrencyMeterHeaderBackColor = clrWhite;
input color CurrencyMeterBackColor = clrWhite;

input int BuySellCellWidth = 110;
int OpenChartWidth = 0;
input color BuyCellBackColor = clrBlue;
input color SellCellBackColor = clrRed;
input color TradeBiasHeaderTextColor = clrBlack;
input color TradeBiasTextColor = clrBlack;
input color TradeBiasHeaderBackColor = clrWhite;

input string RangeMeterAssetHeader_Text = "Hello World!";
input color RangeMeterAssetHeader_TextColor = clrBlack;
input string RangeMeterAssetHeader_FontName = "Arial";
input int RangeMeterAssetHeader_FontSize = 10;

input int CurrencyNameCellWidth = 60;
input int CurrencyStrengthCellWidth = 60;
input color AssetHeaderTextColor = clrBlack;
input color AssetTextColor = clrBlack;
input color AssetHeaderBackColor = clrWhite;
input color AssetBackColor = clrWhite;
input double AssetZone1_Limit = 7.1; input color AssetZone1_Color = clrLime;
input double AssetZone2_Limit = 5.1; input color AssetZone2_Color = clrDodgerBlue;
input double AssetZone3_Limit = 2.1; input color AssetZone3_Color = clrYellow;
input color AssetZone4_Color = clrRed;

input bool BigBiasDisplay = true;
input int ChartPairTradeBiasLable_XOffset = 210;
input int ChartPairTradeBiasLable_YOffset = 5;
input string ChartPairTradeBiasLable_FontName = "Arial";
input int ChartPairTradeBiasLable_FontSize = 14;
input color ChartPairTradeBiasLable_TextColor = LimeGreen;

input color ChartPairTradeBiasType_TextColor_Buy = clrDodgerBlue;
input color ChartPairTradeBiasType_TextColor_Sell = clrRed;

input int ChartPairTradeBiasType_XOffset = 177;
input int ChartPairTradeBiasType_YOffset = 5;
input string ChartPairTradeBiasType_FontName = "Arial";
input int ChartPairTradeBiasType_FontSize = 14;

input int ChartPairTradeBiasArrow_XOffset = 154;
input int ChartPairTradeBiasArrow_YOffset = 3;
input int ChartPairTradeBiasArrow_FontSize = 20;

input int ChartPairStrength_XOffset = 91;
input int ChartPairStrength_YOffset = 5;
input string ChartPairStrength_FontName = "Arial";
input int ChartPairStrength_FontSize = 14;

input int ChartPairSymbolName_XOffset = 1;
input int ChartPairSymbolName_YOffset = 5;
input string ChartPairSymbolName_FontName = "Arial";
input int ChartPairSymbolName_FontSize = 14;
input color ChartPairSymbolName_TextColor = clrOrange;

int TotalSymbols, TotalSymbols_Fav, NumOfSymbols;
string SymbolArray[], SymbolArray_Fav[];
double CurrencyStrength[][2], LastCurrencyStrength[];
double SymbolStrength[][2];

int TableType;
bool ShowHide;
string pref = "CSMD_Ind-";

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
  
//---------- Currency Strength Index Indicator ------////

int t1,t2,t3,t4;
uchar Char[];
double Td[50];
string s7;

t1=0; while(t1<=7) {SetIndexEmptyValue(t1,0); SetIndexStyle(t1,DRAW_NONE); t1++;}

tf=0; t1=1; while(t1<=21 && tf==0) {tf=(PeriodSeconds(PERIOD_CURRENT)==PeriodSeconds(TF[t1]))*t1; t1++;}

TradeComment="CurrencyStrength"; t2=StringToCharArray(Symbol(),Char,0,-1,CP_UTF8)-2; 
t3=-1; t4=-1; t1=0; while(t1<=t2) {if (t3==-1 && Char[t1]>=65 && Char[t1]<=90) {t3=t1;} if (t3!=-1 && t4==-1 && (Char[t1]<65 || Char[t1]>90)) {t4=t1;} t1++;}
Prefix=""; if (t3>0) {Prefix=StringSubstr(Symbol(),0,t3);} Suffix=""; if (t4>0) {Suffix=StringSubstr(Symbol(),t4,0);}
t1=StringLen(Symbol())-StringLen(Prefix)-StringLen(Suffix); Vs[30][1]=StringSubstr(Symbol(),StringLen(Prefix),t1);
s7=StringConcatenate(" ",Vs[30][1]," ",TimeFr[tf]); Vs[30][4]=StringConcatenate(StringSubstr(TradeComment,0,27-StringLen(s7)),s7);

RefreshEveryXMins0=RefreshEveryXMins;
  if (RefreshEveryXMins0 > 240)                              RefreshEveryXMins0 = 240;
  if (RefreshEveryXMins0 > 60 && RefreshEveryXMins0 < 240)   RefreshEveryXMins0 = 60;
  if (RefreshEveryXMins0 > 30 && RefreshEveryXMins0 < 60)    RefreshEveryXMins0 = 30;
  if (RefreshEveryXMins0 > 15 && RefreshEveryXMins0 < 30)    RefreshEveryXMins0 = 15;
  if (RefreshEveryXMins0 > 5  && RefreshEveryXMins0 < 15)    RefreshEveryXMins0 = 5;
  if (RefreshEveryXMins0 > 1  && RefreshEveryXMins0 < 5)     RefreshEveryXMins0 = 1;

CurrencyPairs0  = StringUpper(CurrencyPairs);
  if (CurrencyPairs0=="")  {CurrencyPairs0=Symbol();}
  if (StringSubstr(CurrencyPairs0,StringLen(CurrencyPairs0)-1,1) != ",")  CurrencyPairs0 = CurrencyPairs0 + ",";
  ccCP = StringFindCount(CurrencyPairs0,",");
  for (int i=0; i<40; i++)
    CP[i] = "";
  int comma1 = -1;
  for (int i=0; i<40; i++)  {
    int comma2 = StringFind(CurrencyPairs0,",",comma1+1);
    string temp  = StringSubstr(CurrencyPairs0,comma1+1,comma2-comma1-1);
    CP[i] = ExpandCcy(temp);
    if (comma2 >= StringLen(CurrencyPairs0)-1)   break;
    comma1 = comma2;
  }  

  int checksum = 0;
  string str = "0";
  for (int i=0; i<StringLen(str); i++)  
    checksum += i * StringGetChar(str,i);
  IndiName = "CurrencyStrength-" + (string)checksum;
  IndicatorShortName(IndiName);

  ccy     = Symbol();
  tifr      = Period();
  pnt     = MarketInfo(ccy,MODE_POINT);
  dig     = (int)MarketInfo(ccy,MODE_DIGITS);
  spr     = MarketInfo(ccy,MODE_SPREAD);
  tickval = MarketInfo(ccy,MODE_TICKVALUE);
  if (dig == 3 || dig == 5) {
    pnt     *= 10;
    spr     /= 10;
    tickval *= 10;
  }

  RemoveObjects(IndiName);
  plot_obj();    
  prev_time = -9999;
  
//---------- Currency Strength Index Indicator ------////

//--- indicator buffers mapping
   TableType = DefaultTable;
   ShowHide = true;
   
   GlobalVariableSet(pref+"TableType", TableType);
   
   GlobalVariableSet(pref+"ShowHide", ShowHide);
   
   TableType = (int)GlobalVariableGet(pref+"TableType");
   ShowHide = (bool)GlobalVariableGet(pref+"ShowHide");

   LastCurrency = "";
   CreateDashboard(LastCurrency);
   
   ArrayResize(SymbolArray, 28);
   TotalSymbols = 0;
   if (StringFind(ExcludePairs, "AUDCAD") < 0) {SymbolArray[TotalSymbols] = "AUDCAD"; TotalSymbols++;}
   if (StringFind(ExcludePairs, "AUDCHF") < 0) {SymbolArray[TotalSymbols] = "AUDCHF"; TotalSymbols++;}
   if (StringFind(ExcludePairs, "AUDJPY") < 0) {SymbolArray[TotalSymbols] = "AUDJPY"; TotalSymbols++;}
   if (StringFind(ExcludePairs, "AUDNZD") < 0) {SymbolArray[TotalSymbols] = "AUDNZD"; TotalSymbols++;}
   if (StringFind(ExcludePairs, "AUDUSD") < 0) {SymbolArray[TotalSymbols] = "AUDUSD"; TotalSymbols++;}
   if (StringFind(ExcludePairs, "CADCHF") < 0) {SymbolArray[TotalSymbols] = "CADCHF"; TotalSymbols++;}
   if (StringFind(ExcludePairs, "CADJPY") < 0) {SymbolArray[TotalSymbols] = "CADJPY"; TotalSymbols++;}
   if (StringFind(ExcludePairs, "CHFJPY") < 0) {SymbolArray[TotalSymbols] = "CHFJPY"; TotalSymbols++;}
   if (StringFind(ExcludePairs, "EURAUD") < 0) {SymbolArray[TotalSymbols] = "EURAUD"; TotalSymbols++;}
   if (StringFind(ExcludePairs, "EURCAD") < 0) {SymbolArray[TotalSymbols] = "EURCAD"; TotalSymbols++;}
   if (StringFind(ExcludePairs, "EURCHF") < 0) {SymbolArray[TotalSymbols] = "EURCHF"; TotalSymbols++;}
   if (StringFind(ExcludePairs, "EURGBP") < 0) {SymbolArray[TotalSymbols] = "EURGBP"; TotalSymbols++;}
   if (StringFind(ExcludePairs, "EURJPY") < 0) {SymbolArray[TotalSymbols] = "EURJPY"; TotalSymbols++;}
   if (StringFind(ExcludePairs, "EURNZD") < 0) {SymbolArray[TotalSymbols] = "EURNZD"; TotalSymbols++;}
   if (StringFind(ExcludePairs, "EURUSD") < 0) {SymbolArray[TotalSymbols] = "EURUSD"; TotalSymbols++;}
   if (StringFind(ExcludePairs, "GBPAUD") < 0) {SymbolArray[TotalSymbols] = "GBPAUD"; TotalSymbols++;}
   if (StringFind(ExcludePairs, "GBPCAD") < 0) {SymbolArray[TotalSymbols] = "GBPCAD"; TotalSymbols++;}
   if (StringFind(ExcludePairs, "GBPCHF") < 0) {SymbolArray[TotalSymbols] = "GBPCHF"; TotalSymbols++;}
   if (StringFind(ExcludePairs, "GBPJPY") < 0) {SymbolArray[TotalSymbols] = "GBPJPY"; TotalSymbols++;}
   if (StringFind(ExcludePairs, "GBPNZD") < 0) {SymbolArray[TotalSymbols] = "GBPNZD"; TotalSymbols++;}
   if (StringFind(ExcludePairs, "GBPUSD") < 0) {SymbolArray[TotalSymbols] = "GBPUSD"; TotalSymbols++;}
   if (StringFind(ExcludePairs, "NZDCAD") < 0) {SymbolArray[TotalSymbols] = "NZDCAD"; TotalSymbols++;}
   if (StringFind(ExcludePairs, "NZDCHF") < 0) {SymbolArray[TotalSymbols] = "NZDCHF"; TotalSymbols++;}
   if (StringFind(ExcludePairs, "NZDJPY") < 0) {SymbolArray[TotalSymbols] = "NZDJPY"; TotalSymbols++;}
   if (StringFind(ExcludePairs, "NZDUSD") < 0) {SymbolArray[TotalSymbols] = "NZDUSD"; TotalSymbols++;}
   if (StringFind(ExcludePairs, "USDCAD") < 0) {SymbolArray[TotalSymbols] = "USDCAD"; TotalSymbols++;}
   if (StringFind(ExcludePairs, "USDCHF") < 0) {SymbolArray[TotalSymbols] = "USDCHF"; TotalSymbols++;}
   if (StringFind(ExcludePairs, "USDJPY") < 0) {SymbolArray[TotalSymbols] = "USDJPY"; TotalSymbols++;}
   ArrayResize(SymbolArray, TotalSymbols);
   
   TotalSymbols_Fav = StringSplit(FavoritSymbols, ',', SymbolArray_Fav);
   
//---
   return(INIT_SUCCEEDED);
  }

void OnDeinit(const int reason)
{
//---
   ObjectsDeleteAll(0, pref, -1, -1);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
{
//---
   //---------- Currency Strength Index Indicator ------////
   if (RefreshEveryXMins0 == 0) {
    RemoveObjects(IndiName);
    plot_obj();    
  }
  else {
    if(prev_time != iTime(ccy,RefreshEveryXMins0,0))  {
      RemoveObjects(IndiName);
      plot_obj();
      prev_time = iTime(ccy,RefreshEveryXMins0,0);
  } }      
   //---------- Currency Strength Index Indicator ------////

   bool Changed = false;
   
   //-- Update Currency Strength
   NumOfCurrencies = 0;
   ArrayResize(CurrencyStrength, TotalCurrencies, TotalCurrencies);
   ArrayResize(LastCurrencyStrength, TotalCurrencies, TotalCurrencies);
   for (int CurrencyNum = 0; CurrencyNum < TotalCurrencies; CurrencyNum++)
   {
      double value = CurrencyStrengthIndex_Value(CurrencyNum);
      if (value >= ExcludeValueRange_Min && value <= ExcludeValueRange_Max) continue;
      if (StringFind(ExcludeCurrencyCombination, CurrencyArray[CurrencyNum]) >= 0) continue;
      
      CurrencyStrength[NumOfCurrencies][ValueOrIndex0] = value;
      CurrencyStrength[NumOfCurrencies][ValueOrIndex1] = CurrencyNum;
      
      if (CurrencyStrength[NumOfCurrencies][ValueOrIndex0] != LastCurrencyStrength[NumOfCurrencies]) 
      {
         LastCurrencyStrength[NumOfCurrencies] = CurrencyStrength[NumOfCurrencies][ValueOrIndex0];
         Changed = true;
      }
      NumOfCurrencies++;
   }
   if (TableType == 1) ObjectSetString(0, pref+"TradeBias-Row-1-Col1", OBJPROP_TEXT, "Time: "+TimeToString(TimeCurrent(),TIME_SECONDS));
   else ObjectSetString(0, pref+"TradeBias_Trend-Row-1-Col1", OBJPROP_TEXT, "Time: "+TimeToString(TimeCurrent(),TIME_SECONDS));
   
   if (!Changed) return(rates_total);

   ArrayResize(CurrencyStrength, NumOfCurrencies, TotalCurrencies);
   ArrayResize(LastCurrencyStrength, NumOfCurrencies, TotalCurrencies);
   
   //-- Update Symbol Strength
   NumOfSymbols = 0;
   ArrayResize(SymbolStrength, TotalSymbols, TotalSymbols);
   for (int SymbolNum = 0; SymbolNum < TotalSymbols; SymbolNum++)
   {
      string symbol = SymbolArray[SymbolNum];
      string Base = StringSubstr(symbol, 0, 3);
      string Quote = StringSubstr(symbol, 3, 3);
      double Base_Value = 0, Quote_Value = 0;
      
      for (int CurrencyNum = 0; CurrencyNum < NumOfCurrencies; CurrencyNum++)
      {
         string currency = CurrencyArray[(int)CurrencyStrength[CurrencyNum][ValueOrIndex1]];
         if ((currency == Base && Base_Value != -1) || (currency == Quote && Quote_Value != -1))
         {
            if (currency == Base) Base_Value = CurrencyStrength[CurrencyNum][ValueOrIndex0];
            if (currency == Quote) Quote_Value = CurrencyStrength[CurrencyNum][ValueOrIndex0];            
         }
      }
      if (Base_Value == 0 || Quote_Value == 0) continue;
      
      double min = MathMin(Base_Value, Quote_Value);
      double max = MathMax(Base_Value, Quote_Value);
      SymbolStrength[NumOfSymbols][ValueOrIndex0] = 100-(min/max*100);
      if (Base_Value < Quote_Value) SymbolStrength[NumOfSymbols][ValueOrIndex0] *= -1;
      
      SymbolStrength[NumOfSymbols][ValueOrIndex1] = SymbolNum;
      
      NumOfSymbols++;
   }
   ArrayResize(SymbolStrength, NumOfSymbols, TotalSymbols);
   
   //--- Sort SymbolStrength
   for (int index = 0; index < NumOfSymbols; index++)
   {
      for (int index2 = index+1; index2 < NumOfSymbols; index2++)
      {
         if (MathAbs(SymbolStrength[index][ValueOrIndex0]) < MathAbs(SymbolStrength[index2][ValueOrIndex0]))
         {
            double temp_value = SymbolStrength[index][ValueOrIndex0];
            int temp_index = (int)SymbolStrength[index][ValueOrIndex1];
            
            SymbolStrength[index][ValueOrIndex0] = SymbolStrength[index2][ValueOrIndex0];
            SymbolStrength[index][ValueOrIndex1] = SymbolStrength[index2][ValueOrIndex1];
            
            SymbolStrength[index2][ValueOrIndex0] = temp_value;
            SymbolStrength[index2][ValueOrIndex1] = temp_index;
         }
      }
   }

   //--- Sort CurrencyStrength
   for (int index = 0; index < NumOfCurrencies; index++)
   {
      for (int index2 = index+1; index2 < NumOfCurrencies; index2++)
      {
         if (MathAbs(CurrencyStrength[index][ValueOrIndex0]) < MathAbs(CurrencyStrength[index2][ValueOrIndex0]))
         {
            double temp_value = CurrencyStrength[index][ValueOrIndex0];
            int temp_index = (int)CurrencyStrength[index][ValueOrIndex1];
            
            CurrencyStrength[index][ValueOrIndex0] = CurrencyStrength[index2][ValueOrIndex0];
            CurrencyStrength[index][ValueOrIndex1] = CurrencyStrength[index2][ValueOrIndex1];
            
            CurrencyStrength[index2][ValueOrIndex0] = temp_value;
            CurrencyStrength[index2][ValueOrIndex1] = temp_index;
         }
      }
   }   
   
   CreateDashboard(LastCurrency);
   
//--- return value of prev_calculated for next call
   return(rates_total);
}

void OnChartEvent(const int id,         // Event ID 
                  const long& lparam,   // Parameter of type long event 
                  const double& dparam, // Parameter of type double event 
                  const string& sparam  // Parameter of type string events 
                 )
{
   if (id == CHARTEVENT_OBJECT_CLICK)
   {
      if (sparam == pref+"TableType")
      {
         if (ObjectGetString(0, sparam, OBJPROP_TEXT) == "Default Pairs" || TableType == 4) TableType = 2;
         else if (ObjectGetString(0, sparam, OBJPROP_TEXT) == "Priority Table") TableType = 3;
         else TableType = 1;
         
         GlobalVariableSet(pref+"TableType", TableType);
         
         LastCurrency = "";
         CreateDashboard(LastCurrency);
      }
      if (sparam == pref+"TableType_Signals")
      {
         TableType = 4;
         GlobalVariableSet(pref+"TableType", TableType);
         
         LastCurrency = "";
         CreateDashboard(LastCurrency);
      }
      if (sparam == pref+"ShowHide")
      {
         ShowHide = 1-ShowHide;

         GlobalVariableSet(pref+"ShowHide", ShowHide);
         
         CreateDashboard(LastCurrency);
      }
      if (StringFind(sparam, pref+"TradeBias") == 0
         )
      {
         string symbol = ObjectGetString(0, sparam, OBJPROP_TOOLTIP);
         if (StringLen(symbol) > 2)
         {
            //if (StringFind(sparam, "-Col2") > 0) 
            //{
            //   long OpenedChartID = ChartOpen(symbol+Symbol_Suffix, _Period);
            //   ChartApplyTemplate(OpenedChartID, TemplateFileName);
            //}
            //else 
            if (_Symbol != symbol+Symbol_Suffix) 
            ChartSetSymbolPeriod(0, symbol+Symbol_Suffix, 0);
         }
      }
      if (StringFind(sparam, pref+"CurrencyMeter") == 0
          || StringFind(sparam, pref+"CurrencyTrendMeter") == 0
          || StringFind(sparam, pref+"CurrencyRangeMeter") == 0
         )
      {
         string symbol = ObjectGetString(0, sparam, OBJPROP_TOOLTIP);
         if (StringLen(symbol) > 2)
         {
            //if (StringFind(sparam, "-Col2") > 0) 
            {
               long OpenedChartID = ChartOpen(symbol+Symbol_Suffix, _Period);
               ChartApplyTemplate(OpenedChartID, TemplateFileName);
            }
            //else if (_Symbol != symbol+Symbol_Suffix) 
            //ChartSetSymbolPeriod(0, symbol+Symbol_Suffix, 0);
         }
      }
      if (StringFind(sparam, pref+"Asset") == 0 && StringFind(sparam, "-Col1") > 0)
      {
         if (LastCurrency == ObjectGetString(0, sparam, OBJPROP_TEXT)) LastCurrency = "";
         else LastCurrency = ObjectGetString(0, sparam, OBJPROP_TEXT);
         
         CreateDashboard(LastCurrency);
      }
   }
}

double CurrencyStrengthIndex_Value(int buffer)
{
   if (buffer == 0) return(USD);
   else if (buffer == 1) return(EUR);
   else if (buffer == 2) return(GBP);
   else if (buffer == 3) return(CHF);
   else if (buffer == 4) return(CAD);
   else if (buffer == 5) return(AUD);
   else if (buffer == 6) return(JPY);
   else return(NZD);
}

//+------------------------------------------------------------------+ 
//| Create Edit object                                               | 
//+------------------------------------------------------------------+ 
bool EditCreate(const long             chart_ID=0,               // chart's ID 
                string           name="Edit",              // object name 
                const int              sub_window=0,             // subwindow index 
                const int              x=0,                      // X coordinate 
                const int              y=0,                      // Y coordinate 
                const int              width=50,                 // width 
                const int              height=18,                // height 
                const string           text="Text",              // text 
                const string           font="Arial",             // font 
                const int              font_size=10,             // font size 
                const ENUM_ALIGN_MODE  align=ALIGN_CENTER,       // alignment type 
                const bool             read_only=false,          // ability to edit 
                const ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER, // chart corner for anchoring 
                const color            clr=clrBlack,             // text color 
                const color            back_clr=clrWhite,        // background color 
                const color            border_clr=clrNONE,       // border color 
                const bool             back=false,               // in the background 
                const bool             selection=false,          // highlight to move 
                const bool             hidden=true,              // hidden in the object list 
                const long             z_order=0,                // priority for mouse click 
                const string           tooltip="")                // tooltip
{ 
//--- create edit field 
   name = pref + name;
   
   ObjectCreate(chart_ID,name,OBJ_EDIT,sub_window,0,0);
//--- set object coordinates 
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x); 
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y); 
//--- set object size 
   ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width); 
   ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height); 
//--- set the text 
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text); 
//--- set text font 
   ObjectSetString(chart_ID,name,OBJPROP_FONT,font); 
//--- set font size 
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size); 
//--- set the type of text alignment in the object 
   ObjectSetInteger(chart_ID,name,OBJPROP_ALIGN,align); 
//--- enable (true) or cancel (false) read-only mode 
   ObjectSetInteger(chart_ID,name,OBJPROP_READONLY,read_only); 
//--- set the chart's corner, relative to which object coordinates are defined 
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner); 
//--- set text color 
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr); 
//--- set background color 
   ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,back_clr); 
//--- set border color 
   ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_COLOR,border_clr); 
//--- display in the foreground (false) or background (true) 
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back); 
//--- enable (true) or disable (false) the mode of moving the label by mouse 
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection); 
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection); 
//--- hide (true) or display (false) graphical object name in the object list 
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden); 
//--- set the priority for receiving the event of a mouse click in the chart 
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order); 
  
   ObjectSetString(chart_ID,name,OBJPROP_TOOLTIP,tooltip); 

//--- successful execution 
   return(true); 
} 

//+------------------------------------------------------------------+ 
//| Create a text label                                              | 
//+------------------------------------------------------------------+ 
bool LabelCreate(const long              chart_ID=0,               // chart's ID 
                 string            name="Label",             // label name 
                 const int               sub_window=0,             // subwindow index 
                 const int               x=0,                      // X coordinate 
                 const int               y=0,                      // Y coordinate 
                 const ENUM_BASE_CORNER  corner=CORNER_LEFT_UPPER, // chart corner for anchoring 
                 const string            text="Label",             // text 
                 const string            font="Arial",             // font 
                 const int               font_size=10,             // font size 
                 const color             clr=clrRed,               // color 
                 const double            angle=0.0,                // text slope 
                 const ENUM_ANCHOR_POINT anchor=ANCHOR_LEFT_UPPER, // anchor type 
                 const bool              back=false,               // in the background 
                 const bool              selection=false,          // highlight to move 
                 const bool              hidden=true,              // hidden in the object list 
                 const long              z_order=0)                // priority for mouse click 
{          
   name = pref + name;

//--- create a text label 
   ObjectCreate(chart_ID,name,OBJ_LABEL,sub_window,0,0);
//--- set label coordinates 
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x); 
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y); 
//--- set the chart's corner, relative to which point coordinates are defined 
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner); 
//--- set the text 
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text); 
//--- set text font 
   ObjectSetString(chart_ID,name,OBJPROP_FONT,font); 
//--- set font size 
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size); 
//--- set the slope angle of the text 
   ObjectSetDouble(chart_ID,name,OBJPROP_ANGLE,angle); 
//--- set anchor type 
   ObjectSetInteger(chart_ID,name,OBJPROP_ANCHOR,anchor); 
//--- set color 
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr); 
//--- display in the foreground (false) or background (true) 
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back); 
//--- enable (true) or disable (false) the mode of moving the label by mouse 
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection); 
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection); 
//--- hide (true) or display (false) graphical object name in the object list 
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden); 
//--- set the priority for receiving the event of a mouse click in the chart 
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order); 
//--- successful execution 
   return(true); 
} 

void CreateDashboard(string JustContainCurrency="")
{
   ObjectsDeleteAll(0, pref, -1, -1);
    
   //--- Create TableType lable
   {
      long             chart_ID=0;               // chart's ID 
      string           name="TableType";              // object name 
      int              sub_window=0;             // subwindow index 
      int              x=TableType_XOffset;                      // X coordinate 
      int              y=TableType_YOffset;                      // X coordinate 
      int              width=TableType_Width;                 // width       
      int              height=TableType_Height;                // height 
      string           text;              // text     
      if (TableType == 1) text = "Default Pairs";
      else if (TableType == 2 || TableType == 4) text = "Priority Table";
      else text = "Favorite Pairs";
      
      string           font=FontName;             // font 
      int              font_size=TableType_FontSize;             // font size 
      ENUM_ALIGN_MODE  align=ALIGN_CENTER;       // alignment type 
      bool             read_only=true;          // ability to edit 
      ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER; // chart corner for anchoring 
      color            clr=TableType_TextColor;             // text color 
      color            back_clr=TableType_BackColor;        // background color 
      color            border_clr=clrNONE;       // border color 
      bool             back=false;               // in the background 
      bool             selection=false;          // highlight to move 
      bool             hidden=true;              // hidden in the object list 
      long             z_order=0;
      string           tooltip="Click to change table type";
      
      EditCreate(chart_ID, name, sub_window, x, y, width, height, text, font, font_size, align, read_only, corner, clr, back_clr, border_clr, back, selection, hidden, z_order, tooltip);
   }
   //--- Create ShowHide Arrow
   {
      long             chart_ID=0;               // chart's ID 
      string           name="ShowHide";              // object name 
      int              sub_window=0;             // subwindow index 
      int              xx=TableType_ShowHide_XOffset;                      // X coordinate 
      int              yy=TableType_YOffset;                      // Y coordinate 
      ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER; // chart corner for anchoring 
      string           text=CharToString(244);         
      string           font="Wingdings";             // font 
      int              font_size=TableType_ShowHide_FontSize;             // font size 
      color            clr=TableType_ShowHide_Color;             // text color 
      double           angle=0.0;                // text slope 
      ENUM_ANCHOR_POINT anchor=ANCHOR_LEFT_UPPER; // anchor type 
      bool             back=false;               // in the background 
      bool             selection=false;          // highlight to move 
      bool             hidden=true;              // hidden in the object list 
      long             z_order=0;

      LabelCreate(chart_ID, name, sub_window, xx, yy, corner, text, font, font_size, clr, angle, anchor, back, selection, hidden, z_order);
         
   }
   //--- Create TableType_Signal lable
   {
      long             chart_ID=0;               // chart's ID 
      string           name="TableType_Signals";              // object name 
      int              sub_window=0;             // subwindow index 
      int              x=TableType_Signals_XOffset;                      // X coordinate 
      int              y=TableType_YOffset;                      // X coordinate 
      int              width=TableType_Width;                 // width       
      int              height=TableType_Height;                // height 
      string           text;              // text     
      text = "SIGNALS";      
      string           font=FontName;             // font 
      int              font_size=TableType_FontSize;             // font size 
      ENUM_ALIGN_MODE  align=ALIGN_CENTER;       // alignment type 
      bool             read_only=true;          // ability to edit 
      ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER; // chart corner for anchoring 
      color            clr=TableType_Signals_TextColor;             // text color 
      color            back_clr=TableType_Signals_BackColor;        // background color 
      color            border_clr=clrNONE;       // border color 
      bool             back=false;               // in the background 
      bool             selection=false;          // highlight to move 
      bool             hidden=true;              // hidden in the object list 
      long             z_order=0;
      string           tooltip="Click to change table type";
      
      EditCreate(chart_ID, name, sub_window, x, y, width, height, text, font, font_size, align, read_only, corner, clr, back_clr, border_clr, back, selection, hidden, z_order, tooltip);
   }
   if (!ShowHide) return;
   
   //-- Create "ChartPair-TradeBias"/"ChartPair-Strength"
   if (BigBiasDisplay)
   {
   for (int index = 1; index <= NumOfSymbols; index++)
   {
      if (StringFind(_Symbol, SymbolArray[(int)SymbolStrength[index-1][ValueOrIndex1]]) == 0)
      {
         //--- Create "ChartPair-TradeBiasLable"
         {
         long             chart_ID=0;               // chart's ID 
         string           name="ChartPair-TradeBiasLable";              // object name 
         int              sub_window=0;             // subwindow index 
         int              xx=ChartPairTradeBiasLable_XOffset;                      // X coordinate 
         int              yy=ChartPairTradeBiasLable_YOffset;                      // Y coordinate 
         ENUM_BASE_CORNER corner=CORNER_RIGHT_LOWER; // chart corner for anchoring 
         string           text="Trade Bias: ";         
         string           font=ChartPairTradeBiasLable_FontName;             // font 
         int              font_size=ChartPairTradeBiasLable_FontSize;             // font size 
         color            clr=ChartPairTradeBiasLable_TextColor;             // text color 
         double           angle=0.0;                // text slope 
         ENUM_ANCHOR_POINT anchor=ANCHOR_RIGHT_LOWER; // anchor type 
         bool             back=false;               // in the background 
         bool             selection=false;          // highlight to move 
         bool             hidden=true;              // hidden in the object list 
         long             z_order=0;

         LabelCreate(chart_ID, name, sub_window, xx, yy, corner, text, font, font_size, clr, angle, anchor, back, selection, hidden, z_order);
         }

         //--- Create "ChartPair-TradeBiasType"
         {
         long             chart_ID=0;               // chart's ID 
         string           name="ChartPair-TradeBiasType";              // object name 
         int              sub_window=0;             // subwindow index 
         int              xx=ChartPairTradeBiasType_XOffset;                      // X coordinate 
         int              yy=ChartPairTradeBiasType_YOffset;                      // Y coordinate 
         ENUM_BASE_CORNER corner=CORNER_RIGHT_LOWER; // chart corner for anchoring 
         string           text=(SymbolStrength[index-1][ValueOrIndex0] > 0 ? "Buy" : "Sell");         
         string           font=ChartPairTradeBiasType_FontName;             // font 
         int              font_size=ChartPairTradeBiasType_FontSize;             // font size 
         color            clr=(SymbolStrength[index-1][ValueOrIndex0] > 0 ? ChartPairTradeBiasType_TextColor_Buy : ChartPairTradeBiasType_TextColor_Sell);             // text color 
         double           angle=0.0;                // text slope 
         ENUM_ANCHOR_POINT anchor=ANCHOR_RIGHT_LOWER; // anchor type 
         bool             back=false;               // in the background 
         bool             selection=false;          // highlight to move 
         bool             hidden=true;              // hidden in the object list 
         long             z_order=0;

         LabelCreate(chart_ID, name, sub_window, xx, yy, corner, text, font, font_size, clr, angle, anchor, back, selection, hidden, z_order);
         }

         //--- Create "ChartPair-TradeBiasArrow"
         {
         long             chart_ID=0;               // chart's ID 
         string           name="ChartPair-TradeBiasArrow";              // object name 
         int              sub_window=0;             // subwindow index 
         int              xx=ChartPairTradeBiasArrow_XOffset;                      // X coordinate 
         int              yy=ChartPairTradeBiasArrow_YOffset;                      // Y coordinate 
         ENUM_BASE_CORNER corner=CORNER_RIGHT_LOWER; // chart corner for anchoring 
         string           text=(SymbolStrength[index-1][ValueOrIndex0] > 0 ? CharToString(241) : CharToString(242));
         string           font="Wingdings";//ChartPairTradeBiasArrow_FontName;             // font 
         int              font_size=ChartPairTradeBiasArrow_FontSize;             // font size 
         color            clr=(SymbolStrength[index-1][ValueOrIndex0] > 0 ? ChartPairTradeBiasType_TextColor_Buy : ChartPairTradeBiasType_TextColor_Sell);             // text color 
         double           angle=0.0;                // text slope 
         ENUM_ANCHOR_POINT anchor=ANCHOR_RIGHT_LOWER; // anchor type 
         bool             back=false;               // in the background 
         bool             selection=false;          // highlight to move 
         bool             hidden=true;              // hidden in the object list 
         long             z_order=0;

         LabelCreate(chart_ID, name, sub_window, xx, yy, corner, text, font, font_size, clr, angle, anchor, back, selection, hidden, z_order);
         }
                  
         //-- Create "ChartPair-Strength"
         {
         long             chart_ID=0;               // chart's ID 
         string           name="ChartPair-Strength";              // object name 
         int              sub_window=0;             // subwindow index 
         int              xx=ChartPairStrength_XOffset;                      // X coordinate 
         int              yy=ChartPairStrength_YOffset;                      // Y coordinate 
         ENUM_BASE_CORNER corner=CORNER_RIGHT_LOWER; // chart corner for anchoring 
         string           text=DoubleToString(SymbolStrength[index-1][ValueOrIndex0], 1)+" %";         
         string           font=ChartPairStrength_FontName;             // font 
         int              font_size=ChartPairStrength_FontSize;             // font size 
         color            clr=(SymbolStrength[index-1][ValueOrIndex0] > 0 ? ChartPairTradeBiasType_TextColor_Buy : ChartPairTradeBiasType_TextColor_Sell);             // text color 
         double           angle=0.0;                // text slope 
         ENUM_ANCHOR_POINT anchor=ANCHOR_RIGHT_LOWER; // anchor type 
         bool             back=false;               // in the background 
         bool             selection=false;          // highlight to move 
         bool             hidden=true;              // hidden in the object list 
         long             z_order=0;

         LabelCreate(chart_ID, name, sub_window, xx, yy, corner, text, font, font_size, clr, angle, anchor, back, selection, hidden, z_order);
         }

         //-- Create "ChartPair-SymbolName"
         {
         long             chart_ID=0;               // chart's ID 
         string           name="ChartPair-SymbolName";              // object name 
         int              sub_window=0;             // subwindow index 
         int              xx=ChartPairSymbolName_XOffset;                      // X coordinate 
         int              yy=ChartPairSymbolName_YOffset;                      // Y coordinate 
         ENUM_BASE_CORNER corner=CORNER_RIGHT_LOWER; // chart corner for anchoring 
         string           text=SymbolArray[(int)SymbolStrength[index-1][ValueOrIndex1]];         
         string           font=ChartPairSymbolName_FontName;             // font 
         int              font_size=ChartPairSymbolName_FontSize;             // font size 
         color            clr=ChartPairSymbolName_TextColor;             // text color 
         double           angle=0.0;                // text slope 
         ENUM_ANCHOR_POINT anchor=ANCHOR_RIGHT_LOWER; // anchor type 
         bool             back=false;               // in the background 
         bool             selection=false;          // highlight to move 
         bool             hidden=true;              // hidden in the object list 
         long             z_order=0;

         LabelCreate(chart_ID, name, sub_window, xx, yy, corner, text, font, font_size, clr, angle, anchor, back, selection, hidden, z_order);
         }         
      }
   }
   }
         
   if (TableType == 1) //Default Pairs
   {
   
   //--- Create Currency Meter table
   {
   int x_start = Table_XOffset;
   int y = Table_YOffset;
   for (int index = -1; index <= NumOfSymbols; index++)
   {
   if (index-1 >= 0 && JustContainCurrency != "" && StringFind(SymbolArray[(int)SymbolStrength[index-1][ValueOrIndex1]], JustContainCurrency) < 0) continue;

   for (int column = 1; column <= 2; column++)
   {
      if (index == -1 && column == 2) continue;
      
      long             chart_ID=0;               // chart's ID 
      string           name="CurrencyMeter-Row"+(string)index+"-Col"+(string)column;              // object name 
      int              sub_window=0;             // subwindow index 
      int              x=(column == 1 ? x_start : x_start+SymbolNameCellWidth);                      // X coordinate 
      
      int              width=(column == 1 ? SymbolNameCellWidth : SymbolStrengthCellWidth);                 // width 
      if (index == -1) width = SymbolNameCellWidth + SymbolStrengthCellWidth;
      
      int              height=(index == -1 ? HeaderCellHeight : CellHeight);                // height 
      
      string           text="Text";              // text 
      if (index == -1) text="Currency Meter";
      else if (index == 0) text=(column == 1 ? "Currency" : "Strength %");
      else text=(column == 1 ? SymbolArray[(int)SymbolStrength[index-1][ValueOrIndex1]] : DoubleToString(SymbolStrength[index-1][ValueOrIndex0], 1)+" %");
      
      string           font=FontName;             // font 
      int              font_size=(index == -1 ? HeaderFontSize : FontSize);             // font size 
      ENUM_ALIGN_MODE  align=ALIGN_CENTER;       // alignment type 
      bool             read_only=true;          // ability to edit 
      ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER; // chart corner for anchoring 
      color            clr=(index == -1 ? CurrencyMeterHeaderTextColor : CurrencyMeterTextColor);             // text color 
      color            back_clr=(index == -1 ? CurrencyMeterHeaderBackColor : CurrencyMeterBackColor);        // background color 
      color            border_clr=clrNONE;       // border color 
      bool             back=false;               // in the background 
      bool             selection=false;          // highlight to move 
      bool             hidden=true;              // hidden in the object list 
      long             z_order=0;
      string           tooltip=(index >= 1 && column == 1 ? SymbolArray[(int)SymbolStrength[index-1][ValueOrIndex1]] : "\n");

      EditCreate(chart_ID, name, sub_window, x, y, width, height, text, font, font_size, align, read_only, corner, clr, back_clr, border_clr, back, selection, hidden, z_order, tooltip);
   }
   
   if (index == -1) y += HeaderCellHeight;
   else y += CellHeight;
   
   }
   
   }

   //--- Create Trade Bias table
   {
   int x_start = Table_XOffset + SymbolNameCellWidth + SymbolStrengthCellWidth; 

   int y = Table_YOffset;
   for (int index = -1; index <= NumOfSymbols; index++)
   {
   if (index-1 >= 0 && JustContainCurrency != "" && StringFind(SymbolArray[(int)SymbolStrength[index-1][ValueOrIndex1]], JustContainCurrency) < 0) continue;

   for (int column = 1; column <= 1; column++)
   {
      if (index <= 0 && column == 2) continue;
      
      {
      long             chart_ID=0;               // chart's ID 
      string           name="TradeBias-Row"+(string)index+"-Col"+(string)column;              // object name 
      int              sub_window=0;             // subwindow index 
      int              x=(column == 1 ? x_start : x_start+BuySellCellWidth);                      // X coordinate 
      
      int              width=(column == 1 ? BuySellCellWidth : OpenChartWidth);                 // width 
      if (index <= 0) width = BuySellCellWidth + OpenChartWidth;
      
      int              height=(index == -1 ? HeaderCellHeight : CellHeight);                // height 
      string           font=FontName;             // font
      
      color TradeBiasBackColor;
      string           text="Text";              // text 
      if (index == -1) text="Time: "+TimeToString(TimeCurrent(),TIME_SECONDS);
      else if (index == 0) {text="Trade Bias"; TradeBiasBackColor = CurrencyMeterBackColor;}
      else 
      {
         if (column == 2) {text=CharToString(243); font = "Wingdings";}
         else text=(SymbolStrength[index-1][ValueOrIndex0] > 0 ? "Buy" : "Sell");
         TradeBiasBackColor = (SymbolStrength[index-1][ValueOrIndex0] > 0 ? BuyCellBackColor : SellCellBackColor);
      }
       
      int              font_size=(index == -1 ? HeaderFontSize : FontSize);             // font size 
      ENUM_ALIGN_MODE  align=ALIGN_CENTER;       // alignment type 
      bool             read_only=true;          // ability to edit 
      ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER; // chart corner for anchoring 
      color            clr=(index == -1 ? TradeBiasHeaderTextColor : TradeBiasTextColor);             // text color 
      color            back_clr=(index == -1 ? TradeBiasHeaderBackColor : TradeBiasBackColor);        // background color 
      color            border_clr=clrNONE;       // border color 
      bool             back=false;               // in the background 
      bool             selection=false;          // highlight to move 
      bool             hidden=true;              // hidden in the object list 
      long             z_order=0;
      string           tooltip="\n";
      if (index >= 1) tooltip=SymbolArray[(int)SymbolStrength[index-1][ValueOrIndex1]];
      
      EditCreate(chart_ID, name, sub_window, x, y, width, height, text, font, font_size, align, read_only, corner, clr, back_clr, border_clr, back, selection, hidden, z_order, tooltip);
      }
   }
   
   if (index == -1) y += HeaderCellHeight;
   else y += CellHeight;
   
   }
   
   }
      
   //--- Create Asset table
   {
   int x_start = Table_XOffset + SymbolNameCellWidth + SymbolStrengthCellWidth + BuySellCellWidth + OpenChartWidth;
   int y = Table_YOffset;
   for (int index = -1; index <= NumOfCurrencies; index++)
   {
   for (int column = 1; column <= 2; column++)
   {
      if (index == -1 && column == 2) continue;
      
      long             chart_ID=0;               // chart's ID 
      string           name="Asset-Row"+(string)index+"-Col"+(string)column;              // object name 
      int              sub_window=0;             // subwindow index 
      int              x=(column == 1 ? x_start : x_start+CurrencyNameCellWidth);                      // X coordinate 
      
      int              width=(column == 1 ? CurrencyNameCellWidth : CurrencyStrengthCellWidth);                 // width 
      if (index == -1) width = CurrencyNameCellWidth + CurrencyStrengthCellWidth;
      
      int              height=(index == -1 ? HeaderCellHeight : CellHeight);                // height 
      
      string           text="Text";              // text 
      if (index == -1) text="Asset Meter";
      else if (index == 0) text=(column == 1 ? "Asset" : "Strength");
      else text=(column == 1 ? CurrencyArray[(int)CurrencyStrength[index-1][ValueOrIndex1]] : DoubleToString(CurrencyStrength[index-1][ValueOrIndex0], 1));
      
      string           font=FontName;             // font 
      int              font_size=(index == -1 ? HeaderFontSize : FontSize);             // font size 
      ENUM_ALIGN_MODE  align=ALIGN_CENTER;       // alignment type 
      bool             read_only=true;          // ability to edit 
      ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER; // chart corner for anchoring 
      
      color            clr=(index == -1 ? AssetHeaderTextColor : AssetTextColor);             // text color 
      if (index >= 1 && column == 2)
      {
         double value = CurrencyStrength[index-1][ValueOrIndex0];
         
         if (value >= AssetZone1_Limit) clr = AssetZone1_Color;
         else if (value >= AssetZone2_Limit) clr = AssetZone2_Color;
         else if (value >= AssetZone3_Limit) clr = AssetZone3_Color;
         else clr = AssetZone4_Color;
      }
      
      color            back_clr=(index == -1 ? AssetHeaderBackColor : AssetBackColor);        // background color 
      color            border_clr=AssetTextColor;       // border color 
      bool             back=false;               // in the background 
      bool             selection=false;          // highlight to move 
      bool             hidden=true;              // hidden in the object list 
      long             z_order=0;
      string           tooltip="\n";
      
      EditCreate(chart_ID, name, sub_window, x, y, width, height, text, font, font_size, align, read_only, corner, clr, back_clr, border_clr, back, selection, hidden, z_order, tooltip);
   }
   
   if (index == -1) y += HeaderCellHeight;
   else y += CellHeight;
   
   }
   
   }
   
   }
   
   else if (TableType == 2) //Priority table
   {
   //--- Create Currency Incoming Trades table
   {
   int x_start = Table_XOffset;
   int y = Table_YOffset;
   for (int index = -1; index <= NumOfSymbols; index++)
   {
   if (index >= 1 && !(MathAbs(SymbolStrength[index-1][ValueOrIndex0]) >= CurrencyTrendMeterStrength_Min && MathAbs(SymbolStrength[index-1][ValueOrIndex0]) <= CurrencyTrendMeterStrength_Max)) continue;
   if (index >= 1 && StrongWeakCurrencyActiveForTrendMeter)
   {
      string symbol = SymbolArray[(int)SymbolStrength[index-1][ValueOrIndex1]];
      string Base = StringSubstr(symbol, 0, 3);
      string Quote = StringSubstr(symbol, 3, 3);

      bool Done = true;
      for (int CurrencyNum = 0; CurrencyNum < NumOfCurrencies; CurrencyNum++)
      {
         string currency = CurrencyArray[(int)CurrencyStrength[CurrencyNum][ValueOrIndex1]];
         double value = CurrencyStrength[CurrencyNum][ValueOrIndex0];
         if ((currency == Base || currency == Quote) 
              &&
              !(value >= StrongCurrencyLimit || value <= WeakCurrencyLimit)
             )
         {
            Done = false;
            break;         
         }
      }
      if (!Done) continue;
   }

   for (int column = 1; column <= 2; column++)
   {
      if (index == -1 && column == 2) continue;
      
      long             chart_ID=0;               // chart's ID 
      string           name="CurrencyTrendMeter-Row"+(string)index+"-Col"+(string)column;              // object name 
      int              sub_window=0;             // subwindow index 
      int              x=(column == 1 ? x_start : x_start+SymbolNameCellWidth);                      // X coordinate 
      
      int              width=(column == 1 ? SymbolNameCellWidth : SymbolStrengthCellWidth);                 // width 
      if (index == -1) width = SymbolNameCellWidth + SymbolStrengthCellWidth;
      
      int              height=(index == -1 ? HeaderCellHeight : CellHeight);                // height 
      
      string           text="Text";              // text 
      if (index == -1) text="Incoming Trades";
      else if (index == 0) text=(column == 1 ? "Currency" : "Strength %");
      else text=(column == 1 ? SymbolArray[(int)SymbolStrength[index-1][ValueOrIndex1]] : DoubleToString(SymbolStrength[index-1][ValueOrIndex0], 1)+" %");
      
      string           font=FontName;             // font 
      int              font_size=(index == -1 ? HeaderFontSize : FontSize);             // font size 
      ENUM_ALIGN_MODE  align=ALIGN_CENTER;       // alignment type 
      bool             read_only=true;          // ability to edit 
      ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER; // chart corner for anchoring 
      color            clr=(index == -1 ? CurrencyMeterHeaderTextColor : CurrencyMeterTextColor);             // text color 
      color            back_clr=(index == -1 ? CurrencyMeterHeaderBackColor : CurrencyMeterBackColor);        // background color 
      color            border_clr=clrNONE;       // border color 
      bool             back=false;               // in the background 
      bool             selection=false;          // highlight to move 
      bool             hidden=true;              // hidden in the object list 
      long             z_order=0;
      string           tooltip=(index >= 1 && column == 1 ? SymbolArray[(int)SymbolStrength[index-1][ValueOrIndex1]] : "\n");
      
      EditCreate(chart_ID, name, sub_window, x, y, width, height, text, font, font_size, align, read_only, corner, clr, back_clr, border_clr, back, selection, hidden, z_order, tooltip);
   }
   
   if (index == -1) y += HeaderCellHeight;
   else y += CellHeight;
   
   }
   
   }

   int y_start = 0;
   //--- Create Trade Bias of TrendMeter table
   {
   int x_start = Table_XOffset + SymbolNameCellWidth + SymbolStrengthCellWidth; 
   int y = Table_YOffset;
   
   for (int index = -1; index <= NumOfSymbols; index++)
   {
   if (index >= 1 && !(MathAbs(SymbolStrength[index-1][ValueOrIndex0]) >= CurrencyTrendMeterStrength_Min && MathAbs(SymbolStrength[index-1][ValueOrIndex0]) <= CurrencyTrendMeterStrength_Max)) continue;
   
   if (index >= 1 && StrongWeakCurrencyActiveForTrendMeter)
   {
      string symbol = SymbolArray[(int)SymbolStrength[index-1][ValueOrIndex1]];
      string Base = StringSubstr(symbol, 0, 3);
      string Quote = StringSubstr(symbol, 3, 3);

      bool Done = true;
      for (int CurrencyNum = 0; CurrencyNum < NumOfCurrencies; CurrencyNum++)
      {
         string currency = CurrencyArray[(int)CurrencyStrength[CurrencyNum][ValueOrIndex1]];
         double value = CurrencyStrength[CurrencyNum][ValueOrIndex0];
         if ((currency == Base || currency == Quote) 
              &&
              !(value >= StrongCurrencyLimit || value <= WeakCurrencyLimit)
             )
         {
            Done = false;
            break;         
         }
      }
      if (!Done) continue;
   }   
   for (int column = 1; column <= 1; column++)
   {
      if (index <= 0 && column == 2) continue;
      
      long             chart_ID=0;               // chart's ID 
      string           name="TradeBias_Trend-Row"+(string)index+"-Col"+(string)column;              // object name 
      int              sub_window=0;             // subwindow index 
      int              x=(column == 1 ? x_start : x_start+BuySellCellWidth);                      // X coordinate 
      
      int              width=(column == 1 ? BuySellCellWidth : OpenChartWidth);                 // width 
      if (index <= 0) width = BuySellCellWidth + OpenChartWidth;
      
      int              height=(index == -1 ? HeaderCellHeight : CellHeight);                // height 
      string           font=FontName;             // font 
      
      color TradeBiasBackColor;
      string           text="Text";              // text 
      if (index == -1) text="Time: "+TimeToString(TimeCurrent(),TIME_SECONDS);
      else if (index == 0) {text="Trade Bias"; TradeBiasBackColor = CurrencyMeterBackColor;}
      else 
      {
         if (column == 2) {text=CharToString(243); font = "Wingdings";}
         else text=(SymbolStrength[index-1][ValueOrIndex0] > 0 ? "Buy" : "Sell");
         TradeBiasBackColor = (SymbolStrength[index-1][ValueOrIndex0] > 0 ? BuyCellBackColor : SellCellBackColor);
      }
      
      int              font_size=(index == -1 ? HeaderFontSize : FontSize);             // font size 
      ENUM_ALIGN_MODE  align=ALIGN_CENTER;       // alignment type 
      bool             read_only=true;          // ability to edit 
      ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER; // chart corner for anchoring 
      color            clr=(index == -1 ? TradeBiasHeaderTextColor : TradeBiasTextColor);             // text color 
      color            back_clr=(index == -1 ? TradeBiasHeaderBackColor : TradeBiasBackColor);        // background color 
      color            border_clr=clrNONE;       // border color 
      bool             back=false;               // in the background 
      bool             selection=false;          // highlight to move 
      bool             hidden=true;              // hidden in the object list 
      long             z_order=0;
      string           tooltip="\n";
      if (index >= 1) tooltip=SymbolArray[(int)SymbolStrength[index-1][ValueOrIndex1]];
      
      EditCreate(chart_ID, name, sub_window, x, y, width, height, text, font, font_size, align, read_only, corner, clr, back_clr, border_clr, back, selection, hidden, z_order, tooltip);
   }
   
   if (index == -1) y += HeaderCellHeight;
   else y += CellHeight;

   y_start = y;
   
   }
   
   }
         
   //--- Create Currency Range Meter table
   {
   int y = y_start + CellHeight;
   int x_start = Table_XOffset;
   
   for (int index = 0; index <= NumOfSymbols; index++)
   {
   if (index >= 1 && !(MathAbs(SymbolStrength[index-1][ValueOrIndex0]) >= CurrencyRangeMeterStrength_Min && MathAbs(SymbolStrength[index-1][ValueOrIndex0]) <= CurrencyRangeMeterStrength_Max)) continue;
   
   for (int column = 1; column <= 2; column++)
   {
      if (index == 0 && column == 2) continue;
            
      long             chart_ID=0;               // chart's ID 
      string           name="CurrencyRangeMeter-Row"+(string)index+"-Col"+(string)column;              // object name 
      int              sub_window=0;             // subwindow index 
      int              x=(column == 1 ? x_start : x_start+SymbolNameCellWidth);                      // X coordinate 
      
      int              width=(column == 1 ? SymbolNameCellWidth : SymbolStrengthCellWidth);                 // width 
      if (index == 0) width = SymbolNameCellWidth + SymbolStrengthCellWidth;
      
      int              height=(index == 0 ? HeaderCellHeight : CellHeight);                // height 
      
      string           text="Text";              // text 
      if (index == 0) text="Range Meter";
      else text=(column == 1 ? SymbolArray[(int)SymbolStrength[index-1][ValueOrIndex1]] : DoubleToString(SymbolStrength[index-1][ValueOrIndex0], 1)+" %");
      
      string           font=FontName;             // font 
      int              font_size=(index == 0 ? HeaderFontSize : FontSize);             // font size 
      ENUM_ALIGN_MODE  align=ALIGN_CENTER;       // alignment type 
      bool             read_only=true;          // ability to edit 
      ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER; // chart corner for anchoring 
      color            clr=(index == 0 ? CurrencyMeterHeaderTextColor : CurrencyMeterTextColor);             // text color 
      color            back_clr=(index == 0 ? CurrencyMeterHeaderBackColor : CurrencyMeterBackColor);        // background color 
      color            border_clr=clrNONE;       // border color 
      bool             back=false;               // in the background 
      bool             selection=false;          // highlight to move 
      bool             hidden=true;              // hidden in the object list 
      long             z_order=0;
      string           tooltip=(index >= 1 && column == 1 ? SymbolArray[(int)SymbolStrength[index-1][ValueOrIndex1]] : "\n");

      EditCreate(chart_ID, name, sub_window, x, y, width, height, text, font, font_size, align, read_only, corner, clr, back_clr, border_clr, back, selection, hidden, z_order, tooltip);
   }
   
   if (index == 0) y += HeaderCellHeight;
   else y += CellHeight;
   
   }
   
   }

   //--- Create Trade Bias of RangeMeter table
   {
   int y = y_start + CellHeight;
   int x_start = Table_XOffset + SymbolNameCellWidth + SymbolStrengthCellWidth ; 

   {
         long             chart_ID=0;               // chart's ID 
         string           name="TradeBias_Range";   // object name 
         int              sub_window=0;             // subwindow index 
         int              x=x_start;                // X coordinate 
         ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER; // chart corner for anchoring 
         string           text=RangeMeterAssetHeader_Text;
         string           font=RangeMeterAssetHeader_FontName;             // font 
         int              font_size=RangeMeterAssetHeader_FontSize;        // font size 
         color            clr=RangeMeterAssetHeader_TextColor;             // text color 
         double           angle=0.0;                 // text slope 
         ENUM_ANCHOR_POINT anchor=ANCHOR_CENTER; // anchor type 
         bool             back=false;                // in the background 
         bool             selection=false;           // highlight to move 
         bool             hidden=true;               // hidden in the object list 
         long             z_order=0;
         
         LabelCreate(chart_ID, name, sub_window, x+ ((BuySellCellWidth + OpenChartWidth)/2), y+(CellHeight/2), corner, text, font, font_size, clr, angle, anchor, back, selection, hidden, z_order);      
         
         y += HeaderCellHeight;
   }
   

   for (int index = 1; index <= NumOfSymbols; index++)
   {
   if (!(MathAbs(SymbolStrength[index-1][ValueOrIndex0]) >= CurrencyRangeMeterStrength_Min && MathAbs(SymbolStrength[index-1][ValueOrIndex0]) <= CurrencyRangeMeterStrength_Max)) continue;

   for (int column = 1; column <= 1; column++)
   {      
      long             chart_ID=0;               // chart's ID 
      string           name="TradeBias_Range-Row"+(string)index+"-Col"+(string)column;              // object name 
      int              sub_window=0;             // subwindow index 
      int              x=(column == 1 ? x_start : x_start+BuySellCellWidth);                      // X coordinate 
      int              width=(column == 1 ? BuySellCellWidth : OpenChartWidth);                 // width       
      int              height=CellHeight;                // height 
      color TradeBiasBackColor;
      string           text="Text";              // text 
      string           font=(FontName);             // font 
      
      {
         if (column == 2) {text=CharToString(243); font = "Wingdings";}
         else text=(SymbolStrength[index-1][ValueOrIndex0] > 0 ? "Buy" : "Sell");
         TradeBiasBackColor = (SymbolStrength[index-1][ValueOrIndex0] > 0 ? BuyCellBackColor : SellCellBackColor);
      }
      
      int              font_size=(FontSize);             // font size 
      ENUM_ALIGN_MODE  align=ALIGN_CENTER;       // alignment type 
      bool             read_only=true;          // ability to edit 
      ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER; // chart corner for anchoring 
      color            clr=(TradeBiasTextColor);             // text color 
      color            back_clr=(TradeBiasBackColor);        // background color 
      color            border_clr=clrNONE;       // border color 
      bool             back=false;               // in the background 
      bool             selection=false;          // highlight to move 
      bool             hidden=true;              // hidden in the object list 
      long             z_order=0;
      string           tooltip="\n";
      if (index >= 1) tooltip=SymbolArray[(int)SymbolStrength[index-1][ValueOrIndex1]];
      
      EditCreate(chart_ID, name, sub_window, x, y, width, height, text, font, font_size, align, read_only, corner, clr, back_clr, border_clr, back, selection, hidden, z_order, tooltip);
   }
   
   y += CellHeight;
   
   }
   
   }
      
   }

   else if (TableType == 3) //Favorite Pairs
   {
   //--- Create Currency Incoming Trades table
   {
   int x_start = Table_XOffset;
   int y = Table_YOffset; 
   for (int index = -1; index <= NumOfSymbols; index++)
   {
   if (index >= 1)
   {
   if (!(MathAbs(SymbolStrength[index-1][ValueOrIndex0]) >= CurrencyTrendMeterStrength_Min && MathAbs(SymbolStrength[index-1][ValueOrIndex0]) <= CurrencyTrendMeterStrength_Max)) continue;
   
   string symbol = SymbolArray[(int)SymbolStrength[index-1][ValueOrIndex1]];
   
   if (StrongWeakCurrencyActiveForTrendMeter)
   {
      string Base = StringSubstr(symbol, 0, 3);
      string Quote = StringSubstr(symbol, 3, 3);

      bool Done = true;
      for (int CurrencyNum = 0; CurrencyNum < NumOfCurrencies; CurrencyNum++)
      {
         string currency = CurrencyArray[(int)CurrencyStrength[CurrencyNum][ValueOrIndex1]];
         double value = CurrencyStrength[CurrencyNum][ValueOrIndex0];
         if ((currency == Base || currency == Quote) 
              &&
              !(value >= StrongCurrencyLimit || value <= WeakCurrencyLimit)
             )
         {
            Done = false;
            break;         
         }
      }
      if (!Done) continue;      
   }
   
   bool Done = false;
   for (int i = 0; i < TotalSymbols_Fav; i++)
   {
      if (SymbolArray_Fav[i] == symbol) 
      {
         Done = true;
         break;
      }
   }
   if (!Done) continue;
   
   }
   
   for (int column = 1; column <= 2; column++)
   {
      if (index == -1 && column == 2) continue;
      
      long             chart_ID=0;               // chart's ID 
      string           name="CurrencyTrendMeter-Row"+(string)index+"-Col"+(string)column;              // object name 
      int              sub_window=0;             // subwindow index 
      int              x=(column == 1 ? x_start : x_start+SymbolNameCellWidth);                      // X coordinate 
      
      int              width=(column == 1 ? SymbolNameCellWidth : SymbolStrengthCellWidth);                 // width 
      if (index == -1) width = SymbolNameCellWidth + SymbolStrengthCellWidth;
      
      int              height=(index == -1 ? HeaderCellHeight : CellHeight);                // height 
      
      string           text="Text";              // text 
      if (index == -1) text="Incoming Trades";
      else if (index == 0) text=(column == 1 ? "Currency" : "Strength %");
      else text=(column == 1 ? SymbolArray[(int)SymbolStrength[index-1][ValueOrIndex1]] : DoubleToString(SymbolStrength[index-1][ValueOrIndex0], 1)+" %");
      
      string           font=FontName;             // font 
      int              font_size=(index == -1 ? HeaderFontSize : FontSize);             // font size 
      ENUM_ALIGN_MODE  align=ALIGN_CENTER;       // alignment type 
      bool             read_only=true;          // ability to edit 
      ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER; // chart corner for anchoring 
      color            clr=(index == -1 ? CurrencyMeterHeaderTextColor : CurrencyMeterTextColor);             // text color 
      color            back_clr=(index == -1 ? CurrencyMeterHeaderBackColor : CurrencyMeterBackColor);        // background color 
      color            border_clr=clrNONE;       // border color 
      bool             back=false;               // in the background 
      bool             selection=false;          // highlight to move 
      bool             hidden=true;              // hidden in the object list 
      long             z_order=0;
      string           tooltip=(index >= 1 && column == 1 ? SymbolArray[(int)SymbolStrength[index-1][ValueOrIndex1]] : "\n");
      
      EditCreate(chart_ID, name, sub_window, x, y, width, height, text, font, font_size, align, read_only, corner, clr, back_clr, border_clr, back, selection, hidden, z_order, tooltip);
   }
   
   if (index == -1) y += HeaderCellHeight;
   else y += CellHeight;
   
   }
   
   }

   int y_start = 0;
   //--- Create Trade Bias of TrendMeter table
   {
   int x_start = Table_XOffset + SymbolNameCellWidth + SymbolStrengthCellWidth; 
   int y = Table_YOffset;
   
   for (int index = -1; index <= NumOfSymbols; index++)
   {
   if (index >= 1)
   {
   if (!(MathAbs(SymbolStrength[index-1][ValueOrIndex0]) >= CurrencyTrendMeterStrength_Min && MathAbs(SymbolStrength[index-1][ValueOrIndex0]) <= CurrencyTrendMeterStrength_Max)) continue;
   string symbol = SymbolArray[(int)SymbolStrength[index-1][ValueOrIndex1]];
   
   if (StrongWeakCurrencyActiveForTrendMeter)
   {
      
      string Base = StringSubstr(symbol, 0, 3);
      string Quote = StringSubstr(symbol, 3, 3);

      bool Done = true;
      for (int CurrencyNum = 0; CurrencyNum < NumOfCurrencies; CurrencyNum++)
      {
         string currency = CurrencyArray[(int)CurrencyStrength[CurrencyNum][ValueOrIndex1]];
         double value = CurrencyStrength[CurrencyNum][ValueOrIndex0];
         if ((currency == Base || currency == Quote) 
              &&
              !(value >= StrongCurrencyLimit || value <= WeakCurrencyLimit)
             )
         {
            Done = false;
            break;         
         }
      }
      if (!Done) continue;

   }   
      bool Done = false;
      for (int i = 0; i < TotalSymbols_Fav; i++)
      {
         if (SymbolArray_Fav[i] == symbol) 
         {
            Done = true;
            break;
         }
      }
      if (!Done) continue;      
   }
   
   for (int column = 1; column <= 1; column++)
   {
      if (index <= 0 && column == 2) continue;
      
      long             chart_ID=0;               // chart's ID 
      string           name="TradeBias_Trend-Row"+(string)index+"-Col"+(string)column;              // object name 
      int              sub_window=0;             // subwindow index 
      int              x=(column == 1 ? x_start : x_start+BuySellCellWidth);                      // X coordinate 
      
      int              width=(column == 1 ? BuySellCellWidth : OpenChartWidth);                 // width 
      if (index <= 0) width = BuySellCellWidth + OpenChartWidth;
      
      int              height=(index == -1 ? HeaderCellHeight : CellHeight);                // height 
      string           font=FontName;             // font 
      
      color TradeBiasBackColor;
      string           text="Text";              // text 
      if (index == -1) text="Time: "+TimeToString(TimeCurrent(),TIME_SECONDS);
      else if (index == 0) {text="Trade Bias"; TradeBiasBackColor = CurrencyMeterBackColor;}
      else 
      {
         if (column == 2) {text=CharToString(243); font = "Wingdings";}
         else text=(SymbolStrength[index-1][ValueOrIndex0] > 0 ? "Buy" : "Sell");
         TradeBiasBackColor = (SymbolStrength[index-1][ValueOrIndex0] > 0 ? BuyCellBackColor : SellCellBackColor);
      }
      
      int              font_size=(index == -1 ? HeaderFontSize : FontSize);             // font size 
      ENUM_ALIGN_MODE  align=ALIGN_CENTER;       // alignment type 
      bool             read_only=true;          // ability to edit 
      ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER; // chart corner for anchoring 
      color            clr=(index == -1 ? TradeBiasHeaderTextColor : TradeBiasTextColor);             // text color 
      color            back_clr=(index == -1 ? TradeBiasHeaderBackColor : TradeBiasBackColor);        // background color 
      color            border_clr=clrNONE;       // border color 
      bool             back=false;               // in the background 
      bool             selection=false;          // highlight to move 
      bool             hidden=true;              // hidden in the object list 
      long             z_order=0;
      string           tooltip="\n";
      if (index >= 1) tooltip=SymbolArray[(int)SymbolStrength[index-1][ValueOrIndex1]];
      
      EditCreate(chart_ID, name, sub_window, x, y, width, height, text, font, font_size, align, read_only, corner, clr, back_clr, border_clr, back, selection, hidden, z_order, tooltip);
   }
   
   if (index == -1) y += HeaderCellHeight;
   else y += CellHeight;

   y_start = y;
   
   }
   
   }
         
   //--- Create Currency Range Meter table
   {
   int y = y_start + CellHeight;
   int x_start = Table_XOffset;
   
   for (int index = 0; index <= NumOfSymbols; index++)
   {
   if (index >= 1)
   {
   if (!(MathAbs(SymbolStrength[index-1][ValueOrIndex0]) >= CurrencyRangeMeterStrength_Min && MathAbs(SymbolStrength[index-1][ValueOrIndex0]) <= CurrencyRangeMeterStrength_Max)) continue;
   
   string symbol = SymbolArray[(int)SymbolStrength[index-1][ValueOrIndex1]];
   
   bool Done = false;
   for (int i = 0; i < TotalSymbols_Fav; i++)
   {
      if (SymbolArray_Fav[i] == symbol) 
      {
         Done = true;
         break;
      }
   }
   if (!Done) continue;
   
   }
   
   for (int column = 1; column <= 2; column++)
   {
      if (index == 0 && column == 2) continue;
            
      long             chart_ID=0;               // chart's ID 
      string           name="CurrencyRangeMeter-Row"+(string)index+"-Col"+(string)column;              // object name 
      int              sub_window=0;             // subwindow index 
      int              x=(column == 1 ? x_start : x_start+SymbolNameCellWidth);                      // X coordinate 
      
      int              width=(column == 1 ? SymbolNameCellWidth : SymbolStrengthCellWidth);                 // width 
      if (index == 0) width = SymbolNameCellWidth + SymbolStrengthCellWidth;
      
      int              height=(index == 0 ? HeaderCellHeight : CellHeight);                // height 
      
      string           text="Text";              // text 
      if (index == 0) text="Range Meter";
      else text=(column == 1 ? SymbolArray[(int)SymbolStrength[index-1][ValueOrIndex1]] : DoubleToString(SymbolStrength[index-1][ValueOrIndex0], 1)+" %");
      
      string           font=FontName;             // font 
      int              font_size=(index == 0 ? HeaderFontSize : FontSize);             // font size 
      ENUM_ALIGN_MODE  align=ALIGN_CENTER;       // alignment type 
      bool             read_only=true;          // ability to edit 
      ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER; // chart corner for anchoring 
      color            clr=(index == 0 ? CurrencyMeterHeaderTextColor : CurrencyMeterTextColor);             // text color 
      color            back_clr=(index == 0 ? CurrencyMeterHeaderBackColor : CurrencyMeterBackColor);        // background color 
      color            border_clr=clrNONE;       // border color 
      bool             back=false;               // in the background 
      bool             selection=false;          // highlight to move 
      bool             hidden=true;              // hidden in the object list 
      long             z_order=0;
      string           tooltip=(index >= 1 && column == 1 ? SymbolArray[(int)SymbolStrength[index-1][ValueOrIndex1]] : "\n");

      EditCreate(chart_ID, name, sub_window, x, y, width, height, text, font, font_size, align, read_only, corner, clr, back_clr, border_clr, back, selection, hidden, z_order, tooltip);
   }
   
   if (index == 0) y += HeaderCellHeight;
   else y += CellHeight;
   
   }
   
   }

   //--- Create Trade Bias of RangeMeter table
   {
   int y = y_start + CellHeight;
   int x_start = Table_XOffset + SymbolNameCellWidth + SymbolStrengthCellWidth ; 

   {
         long             chart_ID=0;               // chart's ID 
         string           name="TradeBias_Range";   // object name 
         int              sub_window=0;             // subwindow index 
         int              x=x_start;                // X coordinate 
         ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER; // chart corner for anchoring 
         string           text=RangeMeterAssetHeader_Text;
         string           font=RangeMeterAssetHeader_FontName;             // font 
         int              font_size=RangeMeterAssetHeader_FontSize;        // font size 
         color            clr=RangeMeterAssetHeader_TextColor;             // text color 
         double           angle=0.0;                 // text slope 
         ENUM_ANCHOR_POINT anchor=ANCHOR_CENTER; // anchor type 
         bool             back=false;                // in the background 
         bool             selection=false;           // highlight to move 
         bool             hidden=true;               // hidden in the object list 
         long             z_order=0;
         
         LabelCreate(chart_ID, name, sub_window, x+ ((BuySellCellWidth + OpenChartWidth)/2), y+(CellHeight/2), corner, text, font, font_size, clr, angle, anchor, back, selection, hidden, z_order);      
         
         y += HeaderCellHeight;
   }
   

   for (int index = 1; index <= NumOfSymbols; index++)
   {
   if (!(MathAbs(SymbolStrength[index-1][ValueOrIndex0]) >= CurrencyRangeMeterStrength_Min && MathAbs(SymbolStrength[index-1][ValueOrIndex0]) <= CurrencyRangeMeterStrength_Max)) continue;
   
   {
      string symbol = SymbolArray[(int)SymbolStrength[index-1][ValueOrIndex1]];
      
      bool Done = false;
      for (int i = 0; i < TotalSymbols_Fav; i++)
      {
         if (SymbolArray_Fav[i] == symbol) 
         {
            Done = true;
            break;
         }
      }
      if (!Done) continue;
   }
   
   for (int column = 1; column <= 1; column++)
   {      
      long             chart_ID=0;               // chart's ID 
      string           name="TradeBias_Range-Row"+(string)index+"-Col"+(string)column;              // object name 
      int              sub_window=0;             // subwindow index 
      int              x=(column == 1 ? x_start : x_start+BuySellCellWidth);                      // X coordinate 
      int              width=(column == 1 ? BuySellCellWidth : OpenChartWidth);                 // width       
      int              height=CellHeight;                // height 
      color TradeBiasBackColor;
      string           text="Text";              // text 
      string           font=(FontName);             // font 
      
      {
         if (column == 2) {text=CharToString(243); font = "Wingdings";}
         else text=(SymbolStrength[index-1][ValueOrIndex0] > 0 ? "Buy" : "Sell");
         TradeBiasBackColor = (SymbolStrength[index-1][ValueOrIndex0] > 0 ? BuyCellBackColor : SellCellBackColor);
      }
      
      int              font_size=(FontSize);             // font size 
      ENUM_ALIGN_MODE  align=ALIGN_CENTER;       // alignment type 
      bool             read_only=true;          // ability to edit 
      ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER; // chart corner for anchoring 
      color            clr=(TradeBiasTextColor);             // text color 
      color            back_clr=(TradeBiasBackColor);        // background color 
      color            border_clr=clrNONE;       // border color 
      bool             back=false;               // in the background 
      bool             selection=false;          // highlight to move 
      bool             hidden=true;              // hidden in the object list 
      long             z_order=0;
      string           tooltip="\n";
      if (index >= 1) tooltip=SymbolArray[(int)SymbolStrength[index-1][ValueOrIndex1]];
      
      EditCreate(chart_ID, name, sub_window, x, y, width, height, text, font, font_size, align, read_only, corner, clr, back_clr, border_clr, back, selection, hidden, z_order, tooltip);
   }
   
   y += CellHeight;
   
   }
   
   }
      
   }  

   else if (TableType == 4) //Signals table
   {
   //--- Create Currency Incoming Trades table
   {
   int x_start = Table_XOffset;
   int y = Table_YOffset; 
   for (int index = -1; index <= NumOfSymbols; index++)
   {
   if (index >= 1)
   {
   if (!(MathAbs(SymbolStrength[index-1][ValueOrIndex0]) >= CurrencyTrendMeterStrength_Min && MathAbs(SymbolStrength[index-1][ValueOrIndex0]) <= CurrencyTrendMeterStrength_Max)) continue;
   
   string symbol = SymbolArray[(int)SymbolStrength[index-1][ValueOrIndex1]];
   
   if (StrongWeakCurrencyActiveForTrendMeter)
   {
      string Base = StringSubstr(symbol, 0, 3);
      string Quote = StringSubstr(symbol, 3, 3);

      bool Done = true;
      for (int CurrencyNum = 0; CurrencyNum < NumOfCurrencies; CurrencyNum++)
      {
         string currency = CurrencyArray[(int)CurrencyStrength[CurrencyNum][ValueOrIndex1]];
         double value = CurrencyStrength[CurrencyNum][ValueOrIndex0];
         if ((currency == Base || currency == Quote) 
              &&
              !(value >= StrongCurrencyLimit || value <= WeakCurrencyLimit)
             )
         {
            Done = false;
            break;         
         }
      }
      if (!Done) continue;      
   }
   
   bool Done = false;
   //-- Check Signal
   
   if (!Done) continue;
   
   }
   
   for (int column = 1; column <= 2; column++)
   {
      if (index == -1 && column == 2) continue;
      
      long             chart_ID=0;               // chart's ID 
      string           name="CurrencyTrendMeter-Row"+(string)index+"-Col"+(string)column;              // object name 
      int              sub_window=0;             // subwindow index 
      int              x=(column == 1 ? x_start : x_start+SymbolNameCellWidth);                      // X coordinate 
      
      int              width=(column == 1 ? SymbolNameCellWidth : SymbolStrengthCellWidth);                 // width 
      if (index == -1) width = SymbolNameCellWidth + SymbolStrengthCellWidth;
      
      int              height=(index == -1 ? HeaderCellHeight : CellHeight);                // height 
      
      string           text="Text";              // text 
      if (index == -1) text="Incoming Trades";
      else if (index == 0) text=(column == 1 ? "Currency" : "Strength %");
      else text=(column == 1 ? SymbolArray[(int)SymbolStrength[index-1][ValueOrIndex1]] : DoubleToString(SymbolStrength[index-1][ValueOrIndex0], 1)+" %");
      
      string           font=FontName;             // font 
      int              font_size=(index == -1 ? HeaderFontSize : FontSize);             // font size 
      ENUM_ALIGN_MODE  align=ALIGN_CENTER;       // alignment type 
      bool             read_only=true;          // ability to edit 
      ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER; // chart corner for anchoring 
      color            clr=(index == -1 ? CurrencyMeterHeaderTextColor : CurrencyMeterTextColor);             // text color 
      color            back_clr=(index == -1 ? CurrencyMeterHeaderBackColor : CurrencyMeterBackColor);        // background color 
      color            border_clr=clrNONE;       // border color 
      bool             back=false;               // in the background 
      bool             selection=false;          // highlight to move 
      bool             hidden=true;              // hidden in the object list 
      long             z_order=0;
      string           tooltip=(index >= 1 && column == 1 ? SymbolArray[(int)SymbolStrength[index-1][ValueOrIndex1]] : "\n");
      
      EditCreate(chart_ID, name, sub_window, x, y, width, height, text, font, font_size, align, read_only, corner, clr, back_clr, border_clr, back, selection, hidden, z_order, tooltip);
   }
   
   if (index == -1) y += HeaderCellHeight;
   else y += CellHeight;
   
   }
   
   }

   int y_start = 0;
   //--- Create Trade Bias of TrendMeter table
   {
   int x_start = Table_XOffset + SymbolNameCellWidth + SymbolStrengthCellWidth; 
   int y = Table_YOffset;
   
   for (int index = -1; index <= NumOfSymbols; index++)
   {
   if (index >= 1)
   {
   if (!(MathAbs(SymbolStrength[index-1][ValueOrIndex0]) >= CurrencyTrendMeterStrength_Min && MathAbs(SymbolStrength[index-1][ValueOrIndex0]) <= CurrencyTrendMeterStrength_Max)) continue;
   string symbol = SymbolArray[(int)SymbolStrength[index-1][ValueOrIndex1]];
   
   if (StrongWeakCurrencyActiveForTrendMeter)
   {
      
      string Base = StringSubstr(symbol, 0, 3);
      string Quote = StringSubstr(symbol, 3, 3);

      bool Done = true;
      for (int CurrencyNum = 0; CurrencyNum < NumOfCurrencies; CurrencyNum++)
      {
         string currency = CurrencyArray[(int)CurrencyStrength[CurrencyNum][ValueOrIndex1]];
         double value = CurrencyStrength[CurrencyNum][ValueOrIndex0];
         if ((currency == Base || currency == Quote) 
              &&
              !(value >= StrongCurrencyLimit || value <= WeakCurrencyLimit)
             )
         {
            Done = false;
            break;         
         }
      }
      if (!Done) continue;

   }   
      bool Done = false;
      //-- Check Signal
      
      if (!Done) continue;      
   }
   
   for (int column = 1; column <= 1; column++)
   {
      if (index <= 0 && column == 2) continue;
      
      long             chart_ID=0;               // chart's ID 
      string           name="TradeBias_Trend-Row"+(string)index+"-Col"+(string)column;              // object name 
      int              sub_window=0;             // subwindow index 
      int              x=(column == 1 ? x_start : x_start+BuySellCellWidth);                      // X coordinate 
      
      int              width=(column == 1 ? BuySellCellWidth : OpenChartWidth);                 // width 
      if (index <= 0) width = BuySellCellWidth + OpenChartWidth;
      
      int              height=(index == -1 ? HeaderCellHeight : CellHeight);                // height 
      string           font=FontName;             // font 
      
      color TradeBiasBackColor;
      string           text="Text";              // text 
      if (index == -1) text="Time: "+TimeToString(TimeCurrent(),TIME_SECONDS);
      else if (index == 0) {text="Trade Bias"; TradeBiasBackColor = CurrencyMeterBackColor;}
      else 
      {
         if (column == 2) {text=CharToString(243); font = "Wingdings";}
         else text=(SymbolStrength[index-1][ValueOrIndex0] > 0 ? "Buy" : "Sell");
         TradeBiasBackColor = (SymbolStrength[index-1][ValueOrIndex0] > 0 ? BuyCellBackColor : SellCellBackColor);
      }
      
      int              font_size=(index == -1 ? HeaderFontSize : FontSize);             // font size 
      ENUM_ALIGN_MODE  align=ALIGN_CENTER;       // alignment type 
      bool             read_only=true;          // ability to edit 
      ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER; // chart corner for anchoring 
      color            clr=(index == -1 ? TradeBiasHeaderTextColor : TradeBiasTextColor);             // text color 
      color            back_clr=(index == -1 ? TradeBiasHeaderBackColor : TradeBiasBackColor);        // background color 
      color            border_clr=clrNONE;       // border color 
      bool             back=false;               // in the background 
      bool             selection=false;          // highlight to move 
      bool             hidden=true;              // hidden in the object list 
      long             z_order=0;
      string           tooltip="\n";
      if (index >= 1) tooltip=SymbolArray[(int)SymbolStrength[index-1][ValueOrIndex1]];
      
      EditCreate(chart_ID, name, sub_window, x, y, width, height, text, font, font_size, align, read_only, corner, clr, back_clr, border_clr, back, selection, hidden, z_order, tooltip);
   }
   
   if (index == -1) y += HeaderCellHeight;
   else y += CellHeight;

   y_start = y;
   
   }
   
   }
         
   //--- Create Currency Range Meter table
   {
   int y = y_start + CellHeight;
   int x_start = Table_XOffset;
   
   for (int index = 0; index <= NumOfSymbols; index++)
   {
   if (index >= 1)
   {
   if (!(MathAbs(SymbolStrength[index-1][ValueOrIndex0]) >= CurrencyRangeMeterStrength_Min && MathAbs(SymbolStrength[index-1][ValueOrIndex0]) <= CurrencyRangeMeterStrength_Max)) continue;
   
   string symbol = SymbolArray[(int)SymbolStrength[index-1][ValueOrIndex1]];
   
   bool Done = false;
   //-- Check Signal
   
   if (!Done) continue;
   
   }
   
   for (int column = 1; column <= 2; column++)
   {
      if (index == 0 && column == 2) continue;
            
      long             chart_ID=0;               // chart's ID 
      string           name="CurrencyRangeMeter-Row"+(string)index+"-Col"+(string)column;              // object name 
      int              sub_window=0;             // subwindow index 
      int              x=(column == 1 ? x_start : x_start+SymbolNameCellWidth);                      // X coordinate 
      
      int              width=(column == 1 ? SymbolNameCellWidth : SymbolStrengthCellWidth);                 // width 
      if (index == 0) width = SymbolNameCellWidth + SymbolStrengthCellWidth;
      
      int              height=(index == 0 ? HeaderCellHeight : CellHeight);                // height 
      
      string           text="Text";              // text 
      if (index == 0) text="Range Meter";
      else text=(column == 1 ? SymbolArray[(int)SymbolStrength[index-1][ValueOrIndex1]] : DoubleToString(SymbolStrength[index-1][ValueOrIndex0], 1)+" %");
      
      string           font=FontName;             // font 
      int              font_size=(index == 0 ? HeaderFontSize : FontSize);             // font size 
      ENUM_ALIGN_MODE  align=ALIGN_CENTER;       // alignment type 
      bool             read_only=true;          // ability to edit 
      ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER; // chart corner for anchoring 
      color            clr=(index == 0 ? CurrencyMeterHeaderTextColor : CurrencyMeterTextColor);             // text color 
      color            back_clr=(index == 0 ? CurrencyMeterHeaderBackColor : CurrencyMeterBackColor);        // background color 
      color            border_clr=clrNONE;       // border color 
      bool             back=false;               // in the background 
      bool             selection=false;          // highlight to move 
      bool             hidden=true;              // hidden in the object list 
      long             z_order=0;
      string           tooltip=(index >= 1 && column == 1 ? SymbolArray[(int)SymbolStrength[index-1][ValueOrIndex1]] : "\n");

      EditCreate(chart_ID, name, sub_window, x, y, width, height, text, font, font_size, align, read_only, corner, clr, back_clr, border_clr, back, selection, hidden, z_order, tooltip);
   }
   
   if (index == 0) y += HeaderCellHeight;
   else y += CellHeight;
   
   }
   
   }

   //--- Create Trade Bias of RangeMeter table
   {
   int y = y_start + CellHeight;
   int x_start = Table_XOffset + SymbolNameCellWidth + SymbolStrengthCellWidth ; 

   {
         long             chart_ID=0;               // chart's ID 
         string           name="TradeBias_Range";   // object name 
         int              sub_window=0;             // subwindow index 
         int              x=x_start;                // X coordinate 
         ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER; // chart corner for anchoring 
         string           text=RangeMeterAssetHeader_Text;
         string           font=RangeMeterAssetHeader_FontName;             // font 
         int              font_size=RangeMeterAssetHeader_FontSize;        // font size 
         color            clr=RangeMeterAssetHeader_TextColor;             // text color 
         double           angle=0.0;                 // text slope 
         ENUM_ANCHOR_POINT anchor=ANCHOR_CENTER; // anchor type 
         bool             back=false;                // in the background 
         bool             selection=false;           // highlight to move 
         bool             hidden=true;               // hidden in the object list 
         long             z_order=0;
         
         LabelCreate(chart_ID, name, sub_window, x+ ((BuySellCellWidth + OpenChartWidth)/2), y+(CellHeight/2), corner, text, font, font_size, clr, angle, anchor, back, selection, hidden, z_order);      
         
         y += HeaderCellHeight;
   }
   

   for (int index = 1; index <= NumOfSymbols; index++)
   {
   if (!(MathAbs(SymbolStrength[index-1][ValueOrIndex0]) >= CurrencyRangeMeterStrength_Min && MathAbs(SymbolStrength[index-1][ValueOrIndex0]) <= CurrencyRangeMeterStrength_Max)) continue;
   
   {
      string symbol = SymbolArray[(int)SymbolStrength[index-1][ValueOrIndex1]];
      
      bool Done = false;
      //-- Check Signal
      
      if (!Done) continue;
   }
   
   for (int column = 1; column <= 1; column++)
   {      
      long             chart_ID=0;               // chart's ID 
      string           name="TradeBias_Range-Row"+(string)index+"-Col"+(string)column;              // object name 
      int              sub_window=0;             // subwindow index 
      int              x=(column == 1 ? x_start : x_start+BuySellCellWidth);                      // X coordinate 
      int              width=(column == 1 ? BuySellCellWidth : OpenChartWidth);                 // width       
      int              height=CellHeight;                // height 
      color TradeBiasBackColor;
      string           text="Text";              // text 
      string           font=(FontName);             // font 
      
      {
         if (column == 2) {text=CharToString(243); font = "Wingdings";}
         else text=(SymbolStrength[index-1][ValueOrIndex0] > 0 ? "Buy" : "Sell");
         TradeBiasBackColor = (SymbolStrength[index-1][ValueOrIndex0] > 0 ? BuyCellBackColor : SellCellBackColor);
      }
      
      int              font_size=(FontSize);             // font size 
      ENUM_ALIGN_MODE  align=ALIGN_CENTER;       // alignment type 
      bool             read_only=true;          // ability to edit 
      ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER; // chart corner for anchoring 
      color            clr=(TradeBiasTextColor);             // text color 
      color            back_clr=(TradeBiasBackColor);        // background color 
      color            border_clr=clrNONE;       // border color 
      bool             back=false;               // in the background 
      bool             selection=false;          // highlight to move 
      bool             hidden=true;              // hidden in the object list 
      long             z_order=0;
      string           tooltip="\n";
      if (index >= 1) tooltip=SymbolArray[(int)SymbolStrength[index-1][ValueOrIndex1]];
      
      EditCreate(chart_ID, name, sub_window, x, y, width, height, text, font, font_size, align, read_only, corner, clr, back_clr, border_clr, back, selection, hidden, z_order, tooltip);
   }
   
   y += CellHeight;
   
   }
   
   }
      
   }      
}



//+------------------------------------------------------------------+
void plot_obj()   
//+------------------------------------------------------------------+
{int t1,t2,xp,yp;
color FontColor;
double Td[8][8]; ArrayInitialize(Td, 0);
string s1,s2;

  ArrayInitialize(ccy_strength,0.0);
  ArrayInitialize(ccy_count,0);

  for (int i=0; i<40; i++)   {
    double day_high     = MarketInfo(CP[i],MODE_HIGH);
    double day_low      = MarketInfo(CP[i],MODE_LOW);
    double curr_bid     = MarketInfo(CP[i],MODE_BID);
    double bid_ratio    = DivZero(curr_bid - day_low, day_high - day_low);

    double ind_strength = 0;
    if (bid_ratio >= 0.97)   ind_strength = 9;    else
    if (bid_ratio >= 0.90)   ind_strength = 8;    else
    if (bid_ratio >= 0.75)   ind_strength = 7;    else
    if (bid_ratio >= 0.60)   ind_strength = 6;    else
    if (bid_ratio >= 0.50)   ind_strength = 5;    else
    if (bid_ratio >= 0.40)   ind_strength = 4;    else
    if (bid_ratio >= 0.25)   ind_strength = 3;    else
    if (bid_ratio >= 0.10)   ind_strength = 2;    else
    if (bid_ratio >= 0.03)   ind_strength = 1;

    string temp = StringSubstr(CP[i],0,3);
    for (int j=0; j<=7; j++)   {
      if (Currency[j] == temp)  {
        ccy_strength[j] += ind_strength;
        ccy_count[j]    += 1;
        break;
    } }    

    temp = StringSubstr(CP[i],3,3);
    for (int j=0; j<=7; j++)   {
      if (Currency[j] == temp)  {
        ccy_strength[j] += 9 - ind_strength;
        ccy_count[j]    += 1;
        break;
  } } }    

t1=0; while(t1<=7) {Td[t1][0]=DivZero(ccy_strength[t1],ccy_count[t1]); Td[t1][1]=t1; t1++;} 

USD=Td[0][0]; EUR=Td[1][0]; GBP=Td[2][0]; CHF=Td[3][0]; CAD=Td[4][0]; AUD=Td[5][0]; JPY=Td[6][0]; NZD=Td[7][0]; 
SCurr=Td[StrongCurrency][0]; WCurr=Td[WeakCurrency][0]; ArraySort(Td,8,0,MODE_DESCEND); xp=HorizPos; yp=VertPos;
t1=0; while(t1<=7) {t2=(int)Td[t1][1]; s1=StringConcatenate(Currency[t2],"  ",StrDig(Td[t1][0])); s2=StringConcatenate(IndiName,"-",t1);

FontColor = clrWhite;
if (Td[t1][0] >  Level1)   FontColor = Color1;    else
if (Td[t1][0] >  Level2)   FontColor = Color2;    else
if (Td[t1][0] >  Level3)   FontColor = Color3;    else
if (Td[t1][0] >= Level4)   FontColor = Color4;

if (CSI_FontSize>0) {DrawLabel(s2,s1,PanelCorner,xp,yp,FontSize,FontType,FontColor,false);} yp+=VertSpacing; t1++;} IndAlert();}

void RemoveObjects(string r6)
{int t1;

t1=ObjectsTotal(); while(t1>=0) {if (StringFind(ObjectName(t1),r6,0)!=-1) {ObjectDelete(0,ObjectName(t1));} t1--;}}

string StrDig(double f1)
{double d1;
string s7;

d1=NormalizeDouble(f1,1); s7=DoubleToString(d1,1); return(s7);}

void DrawLabel(string r6,string r7,ENUM_BASE_CORNER x4,int x1,int x2,int x5,string r8,color x3,bool b6)
{if (r7=="" && ObjectFind(0,r6)!=-1) {ObjectDelete(0,r6);}
if (r7!="") {if (ObjectFind(0,r6)==-1) {ObjectCreate(0,r6,OBJ_LABEL,0,0,0);} ObjectSetInteger(0,r6,OBJPROP_CORNER,x4); ObjectSetString(0,r6,OBJPROP_TEXT,r7); 
ObjectSetInteger(0,r6,OBJPROP_FONTSIZE,x5); ObjectSetString(0,r6,OBJPROP_FONT,r8); ObjectSetInteger(0,r6,OBJPROP_COLOR,x3); ObjectSetInteger(0,r6,OBJPROP_BACK,b6);
ObjectSetInteger(0,r6,OBJPROP_XDISTANCE,x1); ObjectSetInteger(0,r6,OBJPROP_YDISTANCE,x2);}}

void IndAlert()
{int t3;
bool b1,b2,b3;
string Ts[10],s1;
static datetime h1;

if (h1<=TimeCurrent()) {b1=(SCurr>StrengthLimit && WCurr<WeaknessLimit); b2=(SCurr<WeaknessLimit && WCurr>StrengthLimit); t3=b1+b2*2;
Ts[1]=Currency[StrongCurrency]; Ts[3]=StrDig(SCurr); Ts[2]=Currency[WeakCurrency]; Ts[4]=StrDig(WCurr);
if (t3>0) {s1=StringConcatenate(Ts[t3]," strength is ",Ts[t3+2]," and ",Ts[3-t3]," weakness is ",Ts[5-t3]);
if (SendEmail==t3 || SendEmail==IncludeReverse) {SendMail(Vs[30][4],s1); b3=true;}
if (SendNotifications==t3 || SendNotifications==IncludeReverse) {SendNotification(StringConcatenate(s1,", ",Vs[30][4])); b3=true;}
if (ScreenShots==t3 || ScreenShots==IncludeReverse) {ChartScreenShot(0,StringConcatenate(Ts[t3],Ts[3-t3],TimeCurrent(),".png"),1920,1080,ALIGN_RIGHT); b3=true;}
if (Alerts==t3 || Alerts==IncludeReverse) {Alert(StringConcatenate(s1,", ",Vs[30][4])); if (AlertSound!="") {PlaySound(AlertSound);} b3=true;}}
if (b3) {h1=TimeCurrent()+AlertsIntervalMinutes*PeriodSeconds(PERIOD_M1);}}}

//+------------------------------------------------------------------+
string StringUpper(string str)
//+------------------------------------------------------------------+
// Converts any lowercase characters in a string to uppercase
// Usage:    string x=StringUpper("The Quick Brown Fox")  returns x = "THE QUICK BROWN FOX"
{
  string outstr = "";
  string lower  = "abcdefghijklmnopqrstuvwxyz";
  string upper  = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
  for(int i=0; i<StringLen(str); i++)  {
    int t1 = StringFind(lower,StringSubstr(str,i,1),0);
    if (t1 >=0)  
      outstr = outstr + StringSubstr(upper,t1,1);
    else
      outstr = outstr + StringSubstr(str,i,1);
  }
  return(outstr);
}  

//+------------------------------------------------------------------+
string StringLower(string str)
//+------------------------------------------------------------------+
// Converts any uppercase characters in a string to lowercase
// Usage:    string x=StringUpper("The Quick Brown Fox")  returns x = "the quick brown fox"
{
  string outstr = "";
  string lower  = "abcdefghijklmnopqrstuvwxyz";
  string upper  = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
  for(int i=0; i<StringLen(str); i++)  {
    int t1 = StringFind(upper,StringSubstr(str,i,1),0);
    if (t1 >=0)  
      outstr = outstr + StringSubstr(lower,t1,1);
    else
      outstr = outstr + StringSubstr(str,i,1);
  }
  return(outstr);
}

//+------------------------------------------------------------------+
string StringTrim(string str)
//+------------------------------------------------------------------+
// Removes all spaces (leading, traing embedded) from a string
// Usage:    string x=StringUpper("The Quick Brown Fox")  returns x = "TheQuickBrownFox"
{
  string outstr = "";
  for(int i=0; i<StringLen(str); i++)  {
    if (StringSubstr(str,i,1) != " ")
      outstr = outstr + StringSubstr(str,i,1);
  }
  return(outstr);
}

//+------------------------------------------------------------------+
double MathFix(double n, int d)
//+------------------------------------------------------------------+
// Returns N rounded to D decimals - works around a precision bug in MQL4
{
  return(MathRound(n*MathPow(10,d)+0.000000000001*MathSign(n))/MathPow(10,d));
}  

//+------------------------------------------------------------------+
double DivZero(double n, double d)
//+------------------------------------------------------------------+
// Divides N by D, and returns 0 if the denominator (D) = 0
// Usage:   double x = DivZero(y,z)  sets x = y/z
{
  if (d == 0) return(0);  else return(n/d);
}  

//+------------------------------------------------------------------+
int MathSign(double n)
//+------------------------------------------------------------------+
// Returns the sign of a number (i.e. -1, 0, +1)
// Usage:   int x=MathSign(-25)   returns x=-1
{
  if (n > 0) return(1);
  else if (n < 0) return (-1);
  else return(0);
}  

//+------------------------------------------------------------------+
int StringFindCount(string str, string str2)
//+------------------------------------------------------------------+
// Returns the number of occurrences of STR2 in STR
// Usage:   int x = StringFindCount("ABCDEFGHIJKABACABB","AB")   returns x = 3
{
  int c = 0;
  for (int i=0; i<StringLen(str); i++)
    if (StringSubstr(str,i,StringLen(str2)) == str2)  c++;
  return(c);
}

//+------------------------------------------------------------------+
string ExpandCcy(string str)
//+------------------------------------------------------------------+
{
  str = StringTrim(StringUpper(str));
  if (StringLen(str) < 1 || StringLen(str) > 2)   return(str);
  string str2 = "";
  for (int i=0; i<StringLen(str); i++)   {
    string s1 = StringSubstr(str,i,1);
    if (s1 == "A")  str2 = str2 + "AUD";     else
    if (s1 == "C")  str2 = str2 + "CAD";     else   
    if (s1 == "E")  str2 = str2 + "EUR";     else   
    if (s1 == "F")  str2 = str2 + "CHF";     else   
    if (s1 == "G")  str2 = str2 + "GBP";     else   
    if (s1 == "J")  str2 = str2 + "JPY";     else   
    if (s1 == "N")  str2 = str2 + "NZD";     else   
    if (s1 == "U")  str2 = str2 + "USD";     else   
    if (s1 == "H")  str2 = str2 + "HKD";     else   
    if (s1 == "S")  str2 = str2 + "SGD";     else   
    if (s1 == "Z")  str2 = str2 + "ZAR";   
  }  
  return(str2);
}

//+------------------------------------------------------------------+
